﻿Lua_AniamlEquipItem = class("Lua_AniamlEquipItem", Lua_ListCell);
function Lua_AniamlEquipItem:ctor(p)
	self:superCall("ctor", p, "AniamlQiangHuaItem_skin");
end

function Lua_AniamlEquipItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-91, 0, 0);
	self.itemImg:removeFun(false)
	self.itemImg.item_bg:addClickFuntion(self, self.onItemEquipClick);

	self.hongdian = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 126, 39, 0, 0);
	self.hongdian.name = "hongdian";
	self.hongdian:setDepth(10);
	self.hongdian:setEnable(false);
end

function Lua_AniamlEquipItem:setData(data)
	self._data = data;
	self.bg.type = UIBasicSprite.Type.Simple;
	
	if self._data.gm_level == 0 then
		self.name.text = self._data.colorName;
	else
		if self._data.gm_level < self._data.gm_maxLvl then
			self.name.text = self._data.colorName .. "[" .. self._data.colorStr .. "]+" .. self._data.gm_level;
		else
			self.name.text = self._data.colorName .. "[" .. self._data.colorStr .. "]+" .. self._data.gm_level .. "(MAX)";
		end
	end
	self.itemImg.data = self._data;
	self.itemImg:showBetterTip(0);
	self.itemImg:showLvlTxt(false);

	self:showRedDot();
end 

function Lua_AniamlEquipItem:showRedDot()
	local value1 = self._data.rank_value == 0;
	local value2 = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG):getBagAllData():getSize() > 0;
	self.hongdian:setEnable(value1 and value2);
end

function Lua_AniamlEquipItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end

function Lua_AniamlEquipItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("ON_ANIMALEQUIP_CLICK", self._data);
end

function Lua_AniamlEquipItem:onItemEquipClick()
	Lua_PackUtil.showItemInfo(self._data, false, false, false)
end

function Lua_AniamlEquipItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.hongdian ~= nil then
		self.hongdian:dispose();
		self.hongdian = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end