Lua_AniamlItem = class("Lua_AniamlItem", Lua_ListCell);
function Lua_AniamlItem:ctor(p)
	self:superCall("ctor", p, "AniamlItem_skin");
end

function Lua_AniamlItem:buildShowItem()
	self:superCall("buildShowItem");

	self.headBg = UICreate.createUIAtlasImage(self.content, "", "", -96, 1, 75, 77)
	self.headBg:setDepth(2);

	self.headIcon = UICreate.createImage(self.content, "", -133, 0, 0, 0);
	self.headIcon.pivot = UIWidget.Pivot.Left;
	self.headIcon:setDepth(3);

	self.hongdian = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 126, 39, 0, 0);
	self.hongdian.name = "hongdian";
	self.hongdian:setDepth(10);
	self.hongdian:setEnable(false);
end

function Lua_AniamlItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.fightTxt.text = LanUtil.formateStr(LanUtil.getValue(124616), tostring(self._data.score));

	self.headBg:setAltas("common_atlas_1", self._data.headBgName);
	self.headIcon:setUrl(self._data.headStr);

	local isHelped = self._data.helped;
	if isHelped then
		self.name.text = self._data.colorName;
		self.fightTxt.colorStr = Lua_ColorDefine.transColor("FFD800");
		self.lineBg:setAltas("common_atlas_2", "ui_common_title_7");
	else
		self.name.text = "[898989]" .. self._data.name .. "[-]";
		self.fightTxt.colorStr = Lua_ColorDefine.transColor("898989");
		self.lineBg:setAltas("common_atlas_2", "ui_common_title_8");
	end

	self.stateObj:SetActive(isHelped);
	self.bg:setGray(not isHelped);
	self.headBg:setGray(not isHelped);
	self.headIcon:setGray(not isHelped);
	self.lineBg:setGray(not isHelped);

	self:showRedDot();
end 

function Lua_AniamlItem:showRedDot()
	local EquipNum = DataCenter.sacredAnimalData:getEquipNumById(self._data.id);
	local value = self._data.helped == false and EquipNum == 5 and DataCenter.sacredAnimalData.helped_count ~= DataCenter.sacredAnimalData.helped_total;
	self.hongdian:setEnable(value or self._data.RedDotState);
end

function Lua_AniamlItem:onPlayerSoundClick(go)
    Lua_MsgUtil.callFunc("ON_ANIMAL_CLICK", self._data);
end

function Lua_AniamlItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end