Lua_AnimalEquipItem = class("Lua_AnimalEquipItem", Lua_ListCell);
function Lua_AnimalEquipItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_AnimalEquipItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg.defaultRoundEffect = true;
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(5, 0, 0);
	self.itemImg:setCanClick(false);
end

function Lua_AnimalEquipItem:setData(data)
	self._data = data;
	
	if type(self._data) == "number" then
		self.itemImg.data = nil;
	else
		self.itemImg.data = data;
	end
end

function Lua_AnimalEquipItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX + 5 - 40, self.itemY - 40, 80, 80);
	if showRect:containeRect(rect) == true then
		self.itemImg:showRoundEffectView(true);
	else
		self.itemImg:showRoundEffectView(false);
	end
end

function Lua_AnimalEquipItem:onPlayerSoundClick(go)
	if self._data ~= nil and type(self._data) ~= "number" then
		Lua_PackUtil.showItemInfo(self._data, nil, nil, true);
	end
end