﻿Lua_AnimalMaterialItem = class("Lua_AnimalMaterialItem", Lua_ListCell);
function Lua_AnimalMaterialItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_AnimalMaterialItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(false);

	self.mask = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 90, 90);
	self.mask.name = "mask";
	self.mask:setDepth(10);
	self.mask:setEnable(false);

	self.selectIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xzk", 0, 0, 90, 90);
	self.selectIcon.name = "selectIcon";
	self.selectIcon:setDepth(11);
	self.selectIcon:setEnable(false);

	self.tipsIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_xz", 0, 0, 56, 44);
	self.tipsIcon.name = "tipsIcon";
	self.tipsIcon:setDepth(12);
	self.tipsIcon:setEnable(false);
end

function Lua_AnimalMaterialItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if type(self._data) == "number" then
		self.itemImg.data = nil;
		self.mask:setEnable(false);
		self.selectIcon:setEnable(false);
		self.tipsIcon:setEnable(false);
	else
		self.itemImg.data = self._data.vo;
		self.mask:setEnable(self._data.selected);
		self.tipsIcon:setEnable(self._data.selected);
		self.selectIcon:setEnable(self._data.selected);
	end
end

function Lua_AnimalMaterialItem:onPlayerSoundClick(go)
	if type(self._data) ~= "number" then
		Lua_MsgUtil.callFunc("ON_ANIMALPACK_CLICK", self._data);
	end
end

function Lua_AnimalMaterialItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.mask ~= nil then
		self.mask:dispose();
		self.mask = nil;
	end
	if self.selectIcon ~= nil then
		self.selectIcon:dispose();
		self.selectIcon = nil;
	end
	if self.tipsIcon ~= nil then
		self.tipsIcon:dispose();
		self.tipsIcon = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end