﻿Lua_AnimalModel = class("Lua_AnimalModel", Lua_DisplayObject)
function Lua_AnimalModel:ctor(p)
	self:superCall("ctor", p, "AnimalModel_skin");
end

function Lua_AnimalModel:buildShowItem()
	self:superCall("buildShowItem");

	self.content.name = "Lua_AnimalModel";

	self.model_headImg = UICreate.createImage(self.content, "", -33, 0, 0, 0);
	self.model_headImg.pivot = UIWidget.Pivot.Center;
	self.model_headImg:setDepth(7);

	local listPosArr = Array();
	listPosArr:add({ posX = -33, posY = 203 });
	listPosArr:add({ posX = -216, posY = 66 });
	listPosArr:add({ posX = -156, posY = -147 });
	listPosArr:add({ posX = 91.5, posY = -145.5 });
	listPosArr:add({ posX = 147, posY = 66 });

	local lineArr = Array();
	lineArr:add({ posX = -33, posY = 120, effectAngle = 0 });
	lineArr:add({ posX = -148.5, posY = 37.5, effectAngle = 75 });
	lineArr:add({ posX = -108, posY = -96, effectAngle = 141 });
	lineArr:add({ posX = 39, posY = -95.5, effectAngle = -141 });
	lineArr:add({ posX = 79.5, posY = 37.5, effectAngle = -75 });

	local itemImg;
	local itemTxt;
	local hongdian;
	local lineEffect;
	self.equList = Array();
	for i = 1, 5 do
		itemImg = Lua_ToolImage.new(self.content);
		itemImg.content.name = i;
		itemImg:setDepth(8);
		itemImg:setLocation(listPosArr[i].posX, listPosArr[i].posY);

		itemTxt = UICreate.createLabel(self.content, "", listPosArr[i].posX, listPosArr[i].posY, 56, 56, 24);
		itemTxt.pivot = UIWidget.Pivot.Center;
		itemTxt.overflowMethod = UILabel.Overflow.ClampContent;
		itemTxt.effectStyle = 3;
		itemTxt.effectColorStr = Lua_ColorDefine.transColor("303A54");
		itemTxt:setDepth(9);

		hongdian = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", listPosArr[i].posX + 30, listPosArr[i].posY + 35, 0, 0)
		hongdian.name = "hongdian";
		hongdian:setDepth(15);
		hongdian:setEnable(false);

		lineEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_shenshoulianxian", "gui_shenshoulianxian", 0, 0);
		lineEffect:setRot(0, 0, lineArr[i].effectAngle);
		lineEffect:setLocation(lineArr[i].posX, lineArr[i].posY);
		lineEffect:setEnable(false);
		lineEffect:SetRenderQueue(self["line"..i], 1, 2, false);

		self.equList:add({itemImg = itemImg, itemTxt = itemTxt, hongdian = hongdian, lineEffect = lineEffect});
	end

	self:addLuaEvent("PLAY_EFFECT_SACRED", self, self.onPlayEffectEvent);
	self:addLuaEvent("ON_ANIMAL_CLICK", self, self.onUpdateModel);
end

function Lua_AnimalModel:setInfo(data)
	self:onUpdateModel(data)
end

function Lua_AnimalModel:onPlayEffectEvent()
	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.model_headImg.mainContent, "/effects/scsEffects/gui_zhuzhanchenggong", "gui_zhuzhanchenggong", 0, 0);
	else
		self.effectZiTi:setEnable(false);
		self.effectZiTi:setEnable(true);
	end
	self.effectZiTi:SetRenderQueue(self.model_headImg, 5, 2, false);
end

function Lua_AnimalModel:onUpdateModel(data)
	self.data = data
	self.model_headImg:setUrl(self.data.headImgStr);
	self.model_headImg:setGray(not self.data.helped);

	for i = 1, 5 do
		self.equList[i].hongdian:setEnable(false)
		self.equList[i].itemImg.data = self.data.equipParts[i];
		self.equList[i].itemTxt.text = self.data.partColorName[i];
		if self.equList[i].itemImg.data ~= nil then
			self.equList[i].itemTxt:setEnable(false)
			self.equList[i].lineEffect:setEnable(true);
		else
			self.equList[i].itemTxt:setEnable(true)
			self.equList[i].lineEffect:setEnable(false);
			self.equList[i].itemImg:removeFun(true)
			self.equList[i].itemImg.item_bg:addClickFuntion(self, self.onItemImgClick)
		end
	end
end

function Lua_AnimalModel:checkRedDot(data)
	local listData = data
	if listData.RedDotArr ~= nil and listData.RedDotArr:getSize() ~= 0 then
		for i = 1, data.RedDotArr:getSize() do
			for a = 1, 5 do
				if listData.RedDotArr[i] == a and self.equList[a].itemImg.data == nil then
					self.equList[a].hongdian:setEnable(true)
				end
			end
		end
	else
		for a = 1, 5 do
			if self.equList[a].itemImg.data ~= nil then
				self.equList[a].hongdian:setEnable(false)
			end
		end
	end
end

function Lua_AnimalModel:UpdateEffectState(value)
	if self.jiHuoEffect == nil then
		self.jiHuoEffect = UICreate.createUIEffect(self.model_headImg.mainContent, "/effects/scsEffects/gui_shenshoujihuo", "gui_shenshoujihuo", 0, 0);
		self.jiHuoEffect:setEnable(value);
	else
		self.jiHuoEffect:setEnable(value);
	end
	self.jiHuoEffect:SetRenderQueue(self.model_headImg, 5, 2, false);
end

function Lua_AnimalModel:onItemImgClick(go)
	local tempIndex = tonumber(go.transform.parent.name)
	if self.equList[tempIndex].itemImg.data ~= nil then
		-- Lua_PackUtil.showItemInfo(self.data.equipParts[tempIndex], nil, nil, true);
	else
		Lua_WindowUtil.openWin("Lua_SacredBagWindow", WinParam.ACTION_OPEN, self.data);
	end
end

function Lua_AnimalModel:dispose()
	for i = 1, self.equList:getSize() do
		self.equList[i].itemImg:dispose();
		self.equList[i].itemTxt:dispose();
		self.equList[i].lineEffect:dispose();
		self.equList[i].hongdian:dispose()
	end
	self.equList:clear();

	self:superCall("dispose");
end