checkRequire("Lua_AnimalModel");
checkRequire("Lua_AniamlItem");
checkRequire("Lua_TxtDesItem");
checkRequire("Lua_SkillAnimalItem");
Lua_SacredAnimalPanel = class("Lua_SacredAnimalPanel", Lua_DisplayObject)
function Lua_SacredAnimalPanel:ctor(p)
	self:superCall("ctor", p, "SacredAnimalPanel_skin");
end

function Lua_SacredAnimalPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.animalModelPanel = Lua_AnimalModel.new(self.content);

	self.skillList = {};

	self.arr = DataCenter.sacredAnimalData.animalArr;
	self.animalList = Lua_DragList.new(self.content, 1, Vector4(0, 8, 292, 540));
	self.animalList:setListCell(Lua_AniamlItem, 115, 290, 1);
	self.animalList:setLocation(-460, -16, 0);
	self.animalList:setLuaArrayData(self.arr, false);
	self.animalList:setSelected(1);
	self.animalList.showList[1]:onPlayerSoundClick();

	self.desList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 260, 180));
	self.desList:setLocation(375, 130, 0);
	self.desList:setListCell(Lua_TxtDesItem, 40, 10, 1);

	self.hongdian = UICreate.createUIAtlasImage(self.zhuBtn.mainContent, "common_atlas_1", "ui_common_hongdian", 80, 30, 0, 0);
	self.hongdian.name = "hongdian"
	self.hongdian:setDepth(10);
	self.hongdian:setEnable(false);

	self.hongdian2 = UICreate.createUIAtlasImage(self.qianghuaBtn.mainContent, "common_atlas_1", "ui_common_hongdian", 80, 30, 0, 0);
	self.hongdian2.name = "hongdian2"
	self.hongdian2:setDepth(10);
	self.hongdian2:setEnable(false);

	self.kuozhanRedDot = UICreate.createUIAtlasImage(self.plus.mainContent, "common_atlas_1", "ui_common_hongdian", 15, 15, 0, 0);
	self.kuozhanRedDot.name = "kuozhanRedDot";
	self.kuozhanRedDot:setSacle(0.7, 0.7);
	self.kuozhanRedDot:setDepth(10);
	self.kuozhanRedDot:setEnable(false);

	self.plus:addClickFuntion(self, self.onPlusClick);
	self.xieBtn:addClickFuntion(self, self.onXieXiaBtnClick);
	self.qianghuaBtn:addClickFuntion(self, self.onQiangHuaBtn);
	self.bagBtn:addClickFuntion(self, self.onBagBtnClick);
	self.zhuBtn:addClickFuntion(self, self.onZhuBtnClick);

	self:onUpdateRedDot();

	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.onUpdateRedDot);
	self:addLuaEvent("ON_ANIMAL_CLICK", self, self.onAnimalClick);
	self:addLuaEvent("UPDATE_ANIMAL_PANEL", self, self.onUpdatePanelInfo);
	Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sInitMsg();
end

function Lua_SacredAnimalPanel:onUpdateRedDot()
	self.kuozhanRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(12004));
	self.hongdian2:setEnable(DataCenter.redDotData:getRedDotStateByEventId(12002));
end

function Lua_SacredAnimalPanel:createSkill()
	if self.data == nil then
		return;
	end

	local item;
	local skillLen = self.data.skillArr:getSize();
	for i = 1, skillLen do
		item = self.skillList[i];
		if item == nil then
			item = Lua_SkillAnimalItem.new(self.content);
			item:setDepth(5);
			item:setLocation(175 +(i % 3) * 127, -60 - (math.floor(i / 3) * 117), 0);
			self.skillList[i] = item;
		end
		self.skillList[i]:setInfo(self.data.skillArr[i]);
		self.skillList[i]:showLockIcon(false);
	end

	for i = #self.skillList, skillLen, -1 do
		if i > skillLen then
			self.skillList[i]:dispose();
			self.skillList[i] = nil;
		end
	end
end

function Lua_SacredAnimalPanel:onXieXiaBtnClick()
	Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sPutOutEquipMsg(self.data.id, self.data.partIdArr);
end

function Lua_SacredAnimalPanel:onBagBtnClick()
	Lua_WindowUtil.openWin("Lua_SacredBagWindow", WinParam.ACTION_OPEN, self.data);
end

function Lua_SacredAnimalPanel:onZhuBtnClick()
	Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sZhuZhanMsg(self.data.id, self.data.helped == false);
end

function Lua_SacredAnimalPanel:onQiangHuaBtn()
	Lua_WindowUtil.openWin("Lua_SacredQiangHuaWindow", WinParam.ACTION_OPEN);
end

function Lua_SacredAnimalPanel:onPlusClick()
	local itemData = DataCenter.sacredAnimalData.costItem;
	self.itemId = itemData[1];
	self.itemNumber = itemData[2];
	self.totalNumber = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.itemId);

	local listData = {};
	listData.owner = self;
	listData.titleName = LanUtil.getValue(124604);
	listData.des = LanUtil.getValue(124603);
	listData.needNumber = self.itemNumber;
	listData.totalNumber = self.totalNumber;
	listData.imgData = Lua_ToolVo.new(self.itemId, 0, 0);
	listData.gotoFun = self.onGoToFun;
	Lua_WindowUtil.openWin("Lua_GoToGainWindow", WinParam.ACTION_OPEN, listData);
end

function Lua_SacredAnimalPanel:onGoToFun(data)
	if self.totalNumber < self.itemNumber then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(124605), Lua_ToolVo.new(self.itemId).colorName));
	else
		Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sKuoZhanMsg();
	end
end

function Lua_SacredAnimalPanel:onAnimalClick(data)
	self.data = data;

	local sacredAnimalData = DataCenter.sacredAnimalData;
	sacredAnimalData.selectedEquId = self.data.id;
	self.desList:setLuaArrayData(self.data.txtArr, false);

	self:createSkill();

	self.animalModelPanel:UpdateEffectState(sacredAnimalData.btnState);
	self.animalModelPanel:checkRedDot(self.data);

	if self.data.helped == true then
		self.zhuBtn.label = LanUtil.getValue(124610);
		self.hongdian:setEnable(false);
	else
		self.zhuBtn.label = LanUtil.getValue(124609);
		self.hongdian:setEnable(sacredAnimalData.btnState and sacredAnimalData.helped_count ~= sacredAnimalData.helped_total);
	end
	self.zhuBtn:setBtnEnable(sacredAnimalData.btnState);
end

function Lua_SacredAnimalPanel:onUpdatePanelInfo()
	local sacredAnimalData = DataCenter.sacredAnimalData;
	self.animalList:setLuaArrayData(sacredAnimalData.animalArr, false);

	self.AnimalNum.text = LanUtil.formateStr(LanUtil.getValue(124602), tostring(sacredAnimalData.helped_count), tostring(sacredAnimalData.helped_total));

	local len = sacredAnimalData.animalArr:getSize();
	local selectIndex = DataCenter.sacredAnimalData.selectedEquId;
	for i = 1, len do
		if selectIndex == nil then
			selectIndex = sacredAnimalData.animalArr[i].id;
			DataCenter.sacredAnimalData.selectedEquId = sacredAnimalData.animalArr[i].id;
		end

	    if sacredAnimalData.animalArr[i].id == selectIndex then
	        self.data = sacredAnimalData.animalArr[selectIndex];
	        self:onAnimalClick(sacredAnimalData.animalArr[selectIndex]);

	        self.animalModelPanel:setInfo(sacredAnimalData.animalArr[selectIndex]);
	        self.animalModelPanel:UpdateEffectState(DataCenter.sacredAnimalData.btnState);
	        self.animalModelPanel:checkRedDot(sacredAnimalData.animalArr[selectIndex]);
	        break;
	    end
	end
	
	self.plus:setEnable(sacredAnimalData.help_total ~= sacredAnimalData.helped_total);
end

function Lua_SacredAnimalPanel:dispose()
	if self.animalModelPanel ~= nil then
		self.animalModelPanel:dispose();
		self.animalModelPanel = nil;
	end
	if self.animalList ~= nil then
		self.animalList:dispose();
		self.animalList = nil;
	end
	if self.desList ~= nil then
		self.desList:dispose();
		self.desList = nil;
	end
	if self.skillList ~= nil then
		for i = 1, #self.skillList do
			self.skillList[i]:dispose();
		end
		self.skillList = nil;
	end

	self:superCall("dispose");
end