checkRequire("Lua_AnimalModel");
checkRequire("Lua_AnimalEquipItem")
Lua_SacredBagWindow = class("Lua_SacredBagWindow", Lua_SecondSizeWindow)
function Lua_SacredBagWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SacredBagWindow";
	self.skinName = "AnimalBagWindow_skin";
	self.titleText = LanUtil.getValue(124606);
end

function Lua_SacredBagWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btn1_startSelect = 1;
	self.btn2_startSelect = 1;

	self:addLuaEvent("PACK_ANIMALINFO_UPDATE", self, self.onAnimalMtUpdate);
	self:addLuaEvent("UPDATE_ANIMAL_PANEL", self, self.onUpdatePackData);

	self.txtList = { [1] = self.ruleTxt1, [2] = self.ruleTxt2 };
	local arr1 = DataCenter.sacredAnimalData.animalEquipColorArr;
	local arr2 = DataCenter.sacredAnimalData.animalEquipStarArr;

	self.ruleTxt1.text = arr1[self.btn1_startSelect];
	self.ruleTxt2.text = arr2[self.btn2_startSelect];

	self.desList = { [1] = arr1, [2] = arr2 };

	self.ModelPanel = Lua_AnimalModel.new(self.content);
	self.ModelPanel:setLocation(-258, -35, 0);

	self.pack_draglist = Lua_DragList.new(self.content, 1, Vector4(292, -38, 560, 350));
	self.pack_draglist:setLocation(-23, 82, 0);
	self.pack_draglist:setListCell(Lua_AnimalEquipItem, 100, 106, 5);

	self:onUpdatePackData(nil);

	self.subBtn1:addClickFuntion(self, self.onSubBtn1Click);
	self.subBtn2:addClickFuntion(self, self.onSubBtn2Click);
	self.getBtn:addClickFuntion(self, self.onGetBtnClick);

	self.help:setEnable(false);
	-- self.help:addClickFuntion(self, self.onHelpClick)
end

function Lua_SacredBagWindow:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(124618));
end

function Lua_SacredBagWindow:onUpdatePackData(data)
	self.data = data
	local bagData = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG);
	local _arr = bagData:getBagAllData();
	local _len = _arr:getSize()
	local arr = Array()
	for i = 1, _len do
		if _arr[i].subType == Lua_PackTypeDefine.SHENSHOU_EQU then
			arr:add(_arr[i])
		end
	end
	self:onEquipRank(arr);
	self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(arr), false);

	if data ~= nil then
		self.ModelPanel:setInfo(self.data);
		self.ModelPanel:UpdateEffectState(DataCenter.sacredAnimalData.btnState);
		self.ModelPanel:checkRedDot(self.data);
	end
end

function Lua_SacredBagWindow:onEquipRank(tempArr)
	local arr = tempArr;
	local len2 = arr:getSize();
	for i = 1, len2 do
		for j = i + 1, len2 do
			if not self:sortFun(arr[i], arr[j]) then
				local temp = arr[i];
				arr[i] = arr[j];
				arr[j] = temp;
			end
		end
	end
	return arr;
end

function Lua_SacredBagWindow:sortFun(a, b)
	if a.color > b.color then
		return true;
	elseif a.color == b.color then
		if a.part > b.part then
			return true;
		elseif a.part == b.part then
			if a.zongheForce > b.zongheForce then
				return true;
			elseif a.zongheForce == b.zongheForce then
				return false;
			end
		end
	else
		return false;
	end
	return true;
end

function Lua_SacredBagWindow:minePackSellGoodsArr(arr)
	local len = arr:getSize();
	local num = 0;
	len = arr:getSize();
	if len < 20 then
		num = 20 - len;
	elseif len % 5 > 0 then
		num = 5 -(len % 5);
	end

	for i = 1, num do
		arr:add(i);
	end
	return arr;
end

function Lua_SacredBagWindow:onSubBtn1Click()
	self.clickIndex = 1;
	if self.dragData1 == nil then
		self.dragData1 = {};
		self.dragData1.datas = Array();
		for i = 1, #self.desList[1] do
			self.dragData1.datas:add(self.desList[1][i]);
		end
		self.dragData1.offsetX = 111;
		self.dragData1.offsetY = -30;
		self.dragData1.width = 200;
		self.dragData1.callBackOwner = self;
		self.dragData1.callBack = self.onDragDownCallBack;
	end
	self.dragData1.selected = self.btn1_startSelect;

	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, self.dragData1);
end

function Lua_SacredBagWindow:onSubBtn2Click()
	self.clickIndex = 2;
	if self.dragData2 == nil then
		self.dragData2 = {};
		self.dragData2.datas = Array();
		for i = 1, #self.desList[2] do
			self.dragData2.datas:add(self.desList[2][i]);
		end
		self.dragData2.offsetX = 401;
		self.dragData2.offsetY = -30;
		self.dragData2.width = 200;
		self.dragData2.callBackOwner = self;
		self.dragData2.callBack = self.onDragDownCallBack;
	end
	self.dragData2.selected = self.btn2_startSelect;
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, self.dragData2);
end

function Lua_SacredBagWindow:showWin(param)
	self.data = param;

	self.ModelPanel:setInfo(self.data);
	self.ModelPanel:UpdateEffectState(DataCenter.sacredAnimalData.btnState);
	self.ModelPanel:checkRedDot(self.data);
end

function Lua_SacredBagWindow:onGetBtnClick()
	Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN, 5);
	Lua_WindowUtil.openWin("Lua_SacredBagWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_SacredWindow", WinParam.ACTION_CLOSE);
end

function Lua_SacredBagWindow:onDragDownCallBack(data)
	if self.clickIndex == 1 then
		self.btn1_startSelect = data
	else
		self.btn2_startSelect = data
	end

	self.txtList[self.clickIndex].text = self.desList[self.clickIndex][data]
	-- 刷新背包
	if self.btn1_startSelect == 1 and self.btn2_startSelect == 1 then
		self:onUpdatePackData(nil);
	else
		local bagData = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG);
		local _arr = bagData:getBagAllData();
		local _len = _arr:getSize()
		local arr = Array()
		for i = 1, _len do
			if _arr[i].subType == Lua_PackTypeDefine.SHENSHOU_EQU then
				arr:add(_arr[i])
			end
		end
		self:onEquipRank(arr);

		local len = arr:getSize();
		local itemArr = Array();
		for i = 1, len do
			if self.btn1_startSelect == 1 then
				if arr[i].star == self.btn2_startSelect - 1 then
					itemArr:add(arr[i]);
				end
			elseif self.btn2_startSelect == 1 then
				if arr[i].color == self.btn1_startSelect - 1 then
					itemArr:add(arr[i]);
				end
			else
				if arr[i].color == self.btn1_startSelect - 1 and arr[i].star == self.btn2_startSelect - 1 then
					itemArr:add(arr[i]);
				end
			end
		end
		self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(itemArr), false);
	end
end

function Lua_SacredBagWindow:onAnimalMtUpdate(data)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG);
	local _arr = bagData:getBagAllData();
	local _len = _arr:getSize()
	local arr = Array()
	for i = 1, _len do
		if _arr[i].subType == Lua_PackTypeDefine.SHENSHOU_EQU then
			arr:add(_arr[i])
		end
	end
	self:onEquipRank(arr)
	self.pack_draglist:setLuaArrayData(self:minePackSellGoodsArr(arr), false);
end

function Lua_SacredBagWindow:dispose()
	if self.pack_draglist ~= nil then
		self.pack_draglist:dispose();
	end
	self:superCall("dispose");
end