checkRequire("Lua_AniamlEquipItem");
checkRequire("Lua_AnimalMaterialItem");
Lua_SacredQiangHuaWindow = class("Lua_SacredQiangHuaWindow", Lua_SecondSizeWindow);
function Lua_SacredQiangHuaWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_SacredQiangHuaWindow";
	self.skinName = "SacredQiangHuaPanel_skin";
	self.titleText = LanUtil.getValue(124622);
end

function Lua_SacredQiangHuaWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.sp:setEnable(false);
	self.shuLianDuBar:setMaxValue(1);
	self.shuLianDuBar:setValue(0);

	self.doubleBox.txt:clearListener();
	self.allBox.txt:clearListener();

	self.hongdian = UICreate.createUIAtlasImage(self.qiangHuaBtn.mainContent, "common_atlas_1", "ui_common_hongdian", 80, 17, 0, 0)
	self.hongdian.name = "hongdian";
	self.hongdian:setDepth(10);
	self.hongdian:setEnable(false);

	self.showItem = Lua_ToolImage.new(self.itemBg.mainContent);
	self.showItem:setDepth(7);
	self.showItem:removeFun(false)
	self.showItem.item_bg:addClickFuntion(self, self.onItemEquipClick);

	self.startIndex = 1;
	self.desArr = Array();
	local arr = DataCenter.sacredAnimalData.animalMaterialColor;
	for i = 1, #arr do
		self.desArr:add(arr[i]);
	end
	self.ruleTxt1.text = self.desArr[self.startIndex];

	self:addLuaEvent("ON_ANIMALEQUIP_CLICK", self, self.updateAnimalEquipInfo);
	self:addLuaEvent("ON_ANIMALPACK_CLICK", self, self.updateMatterSelectState);

	self.itemList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 368, 320));
	self.itemList:setLocation(352, 26, 0);
	self.itemList:setListCell(Lua_AnimalMaterialItem, 90, 92, 4);

	self:updateQiangHuaMatter();

	local arr = DataCenter.sacredAnimalData.animalEquipItemArr;
	arr:sort("rank_value", false);
	self.animalEquipList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 500));
	self.animalEquipList:setListCell(Lua_AniamlEquipItem, 110, 286, 1);
	self.animalEquipList:setLocation(-395, -28, 0);
	self.animalEquipList:setLuaArrayData(arr, false);
	if arr:getSize() > 0 then
		self.animalEquipList:setSelected(1);
		self.animalEquipList.showList[1]:onPlayerSoundClick();
	end

	self.mtText.text = DataCenter.sacredAnimalData.mt_prodfuce;
	self.mtText.clickScale = false;
	self.mtText:addUrlClickFuntion(self, self.onMtTextUrlClick);

	self.qiangHuaBtn:addClickFuntion(self, self.onQiangHuaBtnClick);
	self.help:addClickFuntion(self, self.onHelpClick);
	self.subBtn1:addClickFuntion(self, self.onSubBtn1Click);
	self.allBox:addBoxChange(self, self.onAllSelectedClick);
	
	self:addLuaEvent("PACK_ANIMALINFO_UPDATE", self, self.updateQiangHuaMatter);
	self:addLuaEvent("UPDATE_ANIMAL_PANEL", self, self.onUpdateQiangHuaPanel);
	self:addLuaEvent("PLAY_EFFECT_SACRED", self, self.onPlayEffectEvent);
end

function Lua_SacredQiangHuaWindow:updateQiangHuaMatter()
	local bagData = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG);
	local bagInfoArr = bagData:getBagAllData();
	local len = bagInfoArr:getSize();
	self.mt_Arr = Array();
	if len <= 0 then
		self.mtText:setEnable(true);
		self.itemList:setEnable(false);
	else
		self.itemList:setEnable(true);
		self.mtText:setEnable(false);

		local limitColor = self.startIndex;
		if limitColor == 1 then
			for i = 1, len do
				self.mt_Arr:add({vo = bagInfoArr[i], selected = self.allBox.seleted});
			end
		elseif limitColor == 2 then
			for i = 1, len do
				if bagInfoArr[i].subType == Lua_PackTypeDefine.SHENSHOU_ITEM then
					self.mt_Arr:add({vo = bagInfoArr[i], selected = self.allBox.seleted});
				end
			end
		else
			for i = 1, len do
				if bagInfoArr[i].color <= limitColor - 1 and bagInfoArr[i].subType ~= Lua_PackTypeDefine.SHENSHOU_ITEM then
					self.mt_Arr:add({vo = bagInfoArr[i], selected = self.allBox.seleted});
				end
			end
		end
		local itemArr = self:getItemArr(1);
		local equipArr = self:getItemArr(2);
		for i = 1, equipArr:getSize() do
			itemArr:add(equipArr[i]);
		end
		self.mt_Arr = itemArr;

		self:onUpdateSelectedEquip();

		self.itemList:setLuaArrayData(self:endGoodsArr(self.mt_Arr), false);
	end
end

function Lua_SacredQiangHuaWindow:getItemArr(val)
	local tempArr = Array();
	for i = 1, self.mt_Arr:getSize() do
		if val == 1 then
			if self.mt_Arr[i].vo.subType == Lua_PackTypeDefine.SHENSHOU_ITEM then
				tempArr:add(self.mt_Arr[i]);
			end
		else
			if self.mt_Arr[i].vo.subType ~= Lua_PackTypeDefine.SHENSHOU_ITEM then
				tempArr:add(self.mt_Arr[i]);
			end
		end
	end

	self:onMtRank(tempArr, val);
	return tempArr;
end

function Lua_SacredQiangHuaWindow:onMtRank(tempArr, value)
	local arr = tempArr;
	local len = arr:getSize();
	for i = 1, len do
		for j = i + 1, len do
			if not self:sortFun(arr[i].vo, arr[j].vo, value) then
				local temp = arr[i];
				arr[i] = arr[j];
				arr[j] = temp;
			end
		end
	end
	return arr;
end

function Lua_SacredQiangHuaWindow:sortFun(a, b, value)
	if value == 2 then
		if a.color > b.color then
			return false;
		elseif a.color == b.color then
			if a.zongheForce > b.zongheForce then
				return false;
			elseif a.zongheForce == b.zongheForce then
				return a.part > b.part;
			end
			return true;
		end
	elseif value == 1 then
		return a.color <= b.color;
	end
	return true;
end

function Lua_SacredQiangHuaWindow:onUpdateSelectedEquip()
	self.pack_indexArr = Array();
	if self.data == nil then
		return;
	end

	local len = self.mt_Arr:getSize();
	local itensify = DataCenter.sacredAnimalData.itensify;
	local colorData = DataCenter.sacredAnimalData.configColorData;
	local addNum = 0;
	for i = 1, len do
		if type(self.mt_Arr[i]) ~= "number" and self.mt_Arr[i] ~= nil and self.mt_Arr[i].vo ~= nil and self.mt_Arr[i].selected then
			local list = {};
			list.subType = self.mt_Arr[i].vo.subType;
			list.color = self.mt_Arr[i].vo.color;
			list.index = self.mt_Arr[i].vo.index;
			list.num = self.mt_Arr[i].vo.count;
			
			if list.subType ~= Lua_PackTypeDefine.SHENSHOU_ITEM then
				list.star = self.mt_Arr[i].vo.star;
				list.key = tonumber(self.mt_Arr[i].vo.color .. "00" .. self.mt_Arr[i].vo.part);
				list.gm_intensify = itensify[list.color][list.star + 1];

				local colorProgress = 0;
				for i = 1, self.mt_Arr[i].vo.gm_level do
					colorProgress = colorProgress + colorData[list.key].progress[i];
				end
				list.gm_intensify = list.gm_intensify + colorProgress;
			end

			if self.mt_Arr[i].vo.gm_intensify ~= nil and self.mt_Arr[i].vo.gm_intensify ~= 0 then
				list.gm_intensify = self.mt_Arr[i].vo.gm_intensify * list.num;
			end
			addNum = addNum + list.gm_intensify;
			self.pack_indexArr:add(list);
		end
	end

	if self.data.rank_value ~= 1 then
		if addNum == 0 then
			self.shuLianDuBar:setText(self.data.gm_progress.."/"..self.data.high_progress);
		else
			self.shuLianDuBar:setText(self.data.gm_progress.."[00E125]+"..addNum.."[-]/"..self.data.high_progress);
		end
		self.shuLianDuBar:setMaxValue(self.data.high_progress);
		self.shuLianDuBar:setValue(self.data.gm_progress);
	else
		self.shuLianDuBar:setText(LanUtil.formateStr(LanUtil.getValue(124620), tostring(self.data.gm_progress)));
		self.shuLianDuBar:setMaxValue(self.data.high_progress);
		self.shuLianDuBar:setValue(self.data.gm_progress);
	end
end

-- 少于16补满16，多于16求余补满4个
function Lua_SacredQiangHuaWindow:endGoodsArr(arr)
	local len = arr:getSize();
	local num = 0;
	if len < 16 then
		num = 16 - len;
	elseif len % 4 > 0 then
		num = 4 - (len % 4);
	end

	for i = 1, num do
		arr:add(i);
	end
	return arr;
end

function Lua_SacredQiangHuaWindow:updateAnimalEquipInfo(data)
	self.data = data; -- Lua_AniamlEquipItem

	self.showItem.data = self.data;

	self.desLbl_1.text = self.data.qiangHua_atrr_1[1]
	self.desLbl_2.text = self.data.qiangHua_atrr_1[2]
	self.desLbl_1_2.text = "[00E125]" .. self.data.qiangHua_atrr_2[1] .. "[-]";
	self.desLbl_2_2.text = "[00E125]" .. self.data.qiangHua_atrr_2[2] .. "[-]";

	if self.data.rank_value ~= 1 then
		self.lvlLbl_1.text = LanUtil.formateStr(LanUtil.getValue(124612), tostring(self.data.gm_level));
		self.lvlLbl_2.text = LanUtil.formateStr(LanUtil.getValue(124613), tostring(self.data.gm_level + 1));
		-- self.desObj1.transform.localPosition = Vector3(117, -51.8, 0);
		LuaUtil.setObjPos(self.desObj1, 117, -51.8, 0);
	else
		self.lvlLbl_1.text = LanUtil.formateStr(LanUtil.getValue(124621), tostring(self.data.gm_level));
		self.lvlLbl_2.text = LanUtil.getValue(124619);
		-- self.desObj1.transform.localPosition = Vector3(177, -51.8, 0);
		LuaUtil.setObjPos(self.desObj1, 177, -51.8, 0);
	end
	self.sp:setEnable(self.data.rank_value ~= 1);
	self.desObj2:SetActive(self.data.rank_value ~= 1);

	self:showRedDot();
	self:onUpdateSelectedEquip();
end

function Lua_SacredQiangHuaWindow:showRedDot()
	local value1 = self.data.rank_value == 0;
	local value2 = DataCenter.packData:getBagType(Lua_PackData.SACRED_ANIMAL_BAG):getBagAllData():getSize() > 0;
	self.hongdian:setEnable(value1 and value2);
end

function Lua_SacredQiangHuaWindow:updateMatterSelectState(data)
	self.mtData = data;
	for i = 1, self.mt_Arr:getSize() do
		if self.mt_Arr[i] == self.mtData then
			if type(self.mt_Arr[i]) ~= "number" then
				self.mt_Arr[i].selected = not self.mt_Arr[i].selected;
			end
		end
	end
	self.itemList:setLuaArrayData(self:endGoodsArr(self.mt_Arr), false);
	self:onUpdateSelectedEquip();
end

function Lua_SacredQiangHuaWindow:onUpdateQiangHuaPanel()
	local arr = DataCenter.sacredAnimalData.animalEquipItemArr;
	arr:sort("rank_value", false);
	self.animalEquipList:setLuaArrayData(arr, false);

	for i = 1, arr:getSize() do
		if arr[i] ~= nil and arr[i].bolSelected == self.data.bolSelected then
			self.data = arr[i];
			if self.data.rank_value == 1 then
				self.animalEquipList:setSelected(1);
				self.animalEquipList.showList[1]:onPlayerSoundClick();
			else
				self:updateAnimalEquipInfo(self.data)
			end
			break;
		end
	end
end

function Lua_SacredQiangHuaWindow:onPlayEffectEvent()
	if self.effect == nil then
		self.effect = UICreate.createUIEffect(self.itemBg.mainContent, "/effects/scsEffects/gui_qianghua", "gui_qianghua", 0, 0);
		self.effect:SetRenderQueue(self.lvlLbl_1, 5, 2, false);
	end
	self.effect:setEnable(false);
	self.effect:setEnable(true);

	if self.effectZiTi == nil then
		self.effectZiTi = UICreate.createUIEffect(self.itemBg.mainContent, "/effects/scsEffects/gui_qianghuaziti", "gui_qianghuaziti", 0, -160);
		self.effectZiTi:SetRenderQueue(self.lvlLbl_1, 5, 2, false);
	end
	self.effectZiTi:setEnable(false);
	self.effectZiTi:setEnable(true);
end

function Lua_SacredQiangHuaWindow:onItemEquipClick()
	Lua_PackUtil.showItemInfo(self.data, false, false, false)
end

function Lua_SacredQiangHuaWindow:onMtTextUrlClick(url)
	local list = DataCenter.sacredAnimalData:getWindowNameByUrl(tonumber(url));
	if list[1] ~= nil and list[2] ~= nil then
		if list[2] == -1 then
			Lua_WindowUtil.openWin(list[1], WinParam.ACTION_OPEN);
		else
			Lua_WindowUtil.openWin(list[1], WinParam.ACTION_OPEN, list[2]);
		end
	end
	Lua_WindowUtil.openWin("Lua_SacredWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_SacredQiangHuaWindow", WinParam.ACTION_CLOSE);
end

function Lua_SacredQiangHuaWindow:onQiangHuaBtnClick()
	if self.pack_indexArr == nil or self.pack_indexArr:getSize() <= 0 then
		OperateAlert.show(LanUtil.getValue(124611));
	else
		if self.doubleBox.seleted == true then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, type = 1, subFun = self.onSureFun,
				des = LanUtil.formateStr(LanUtil.getValue(124608), tostring(self.moneyCost))});
		else
			self:onSureFun();
		end
	end
end

function Lua_SacredQiangHuaWindow.Get:moneyCost()
	local itensify = DataCenter.sacredAnimalData.itensify;
	local totalValue = 0;
	local value;
	local vo;
	for i = 1, self.pack_indexArr:getSize() do
		vo = self.pack_indexArr[i];
		if vo.key ~= nil then
			value = itensify[vo.color][vo.star + 1];
		elseif vo.gm_intensify ~= nil then
			value = vo.gm_intensify;
		else
			value = 0;
		end
		totalValue = totalValue + value * vo.num
	end

	local price_div = DataCenter.sacredAnimalData.item_price_div;
	local cost = math.ceil(totalValue / price_div);
	return cost;
end

function Lua_SacredQiangHuaWindow:onSureFun(data)
	local double_intensify = self.doubleBox.seleted;
	local isColor = false;
	local vo;
	for i = 1, self.pack_indexArr:getSize() do
		vo = self.pack_indexArr[i];
		if vo ~= nil and vo.color >= 4 and vo.subType ~= Lua_PackTypeDefine.SHENSHOU_ITEM then
			isColor = true;
			break;
		end
	end

	if isColor == true then
		Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {owner = self, des = LanUtil.getValue(124615),
		type = 1, subFun = self.onSureClick});
	else
		Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sQiangHuaEquipMsg(self.data.master_id, self.data.part,
			self.pack_indexArr, self.doubleBox.seleted);
	end
end

function Lua_SacredQiangHuaWindow:onSureClick()
	Lua_ProxyManager.getProxy("Lua_SacredAnimalProxy"):sQiangHuaEquipMsg(self.data.master_id, self.data.part, 
		self.pack_indexArr, self.doubleBox.seleted);
	Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_CLOSE);
end

function Lua_SacredQiangHuaWindow:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(124607));
end

function Lua_SacredQiangHuaWindow:onSubBtn1Click()
	if self.dragData == nil then
		self.dragData = {};
		self.dragData.datas = self.desArr;
		self.dragData.offsetX = 282;
		self.dragData.offsetY = -29;
		self.dragData.width = 200;
		self.dragData.callBackOwner = self;
		self.dragData.callBack = self.onDragDownCallBack;
	end
	self.dragData.selected = self.startIndex;
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, self.dragData);
end

function Lua_SacredQiangHuaWindow:onDragDownCallBack(data)
	self.startIndex = data;
	self:updateQiangHuaMatter();
	self.ruleTxt1.text = self.desArr[data];
end

function Lua_SacredQiangHuaWindow:onAllSelectedClick(go)
	for i = 1, self.mt_Arr:getSize() do
		if type(self.mt_Arr[i]) ~= "number" then
			self.mt_Arr[i].selected = self.allBox.seleted;
		end
	end
	self.itemList:setLuaArrayData(self:endGoodsArr(self.mt_Arr), false);
	self:onUpdateSelectedEquip();
end

function Lua_SacredQiangHuaWindow:dispose()
	if self.hongdian ~= nil then
		self.hongdian:dispose();
		self.hongdian = nil;
	end
	if self.showItem ~= nil then
		self.showItem:dispose();
		self.showItem = nil;
	end
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.animalEquipList ~= nil then
		self.animalEquipList:dispose();
		self.animalEquipList = nil;
	end

	self:superCall("dispose");
end