checkRequire("Lua_SacredAnimalPanel"); -- 神兽
checkRequire("Lua_CloakPanel"); -- 披风
checkRequire("Lua_ArmySoulPanel"); -- 军魂
Lua_SacredWindow = class("Lua_SacredWindow", Lua_FullSizeTabWindow);
function Lua_SacredWindow:ctor()
	local list = Array();
	list:add({name = LanUtil.getValue(124600), eventIds = {12003, 12004, 12002}, panel = Lua_SacredAnimalPanel, openId = 10110, titleAltas = "titleName_altas_1", titleSprite = "shenshou"});
	list:add({name = LanUtil.getValue(140000), eventIds = {22036, 22037, 22038, 22039, 22040}, panel = Lua_CloakPanel,openId = 10184, titleAltas = "titleName_altas_1", titleSprite = "pifeng"});
	list:add({name = LanUtil.getValue(140500), eventIds = {22041, 22042, 22043, 22044, 22045, 22046, 22047}, panel = Lua_ArmySoulPanel, openId = 10193, titleAltas = "titleName_altas_1", titleSprite = "junhun"});

	self:superCall("ctor", list);
	self.windowName = "Lua_SacredWindow";
end

function Lua_SacredWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:checkBtnRedDot();
	self:addLuaEvent("UPDATE_SACRED_REDDOT", self, self.checkBtnRedDot);
end

function Lua_SacredWindow:checkBtnRedDot(value)
	local hasRedDot = false
	local animalArr = DataCenter.sacredAnimalData.animalArr
	local len = animalArr:getSize()
	for i = 1, len do
		hasRedDot = DataCenter.sacredAnimalData:getEquipRedDotStateById(i)
		if hasRedDot == true then
			break;
		end
	end

	if hasRedDot == true or value == true then
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", true);
		self:setRedDotStateByIndex(1, true);
	else
		Lua_MsgUtil.callFunc("NOTICE_BESTRONG_STATE", false);
		self:setRedDotStateByIndex(1, false);
	end
end

function Lua_SacredWindow:showWin(param)
	self:superCall("showWin", param);

	if type(param) == "number" then
		self:setSelected(param, true);
	elseif type(param) == "table" and param.openIdx ~= nil then
		self:setSelected(param.openIdx, true);
	end
end