--军团背包
Lua_ArmyEquipPackWindow = class("Lua_ArmyEquipPackWindow", Lua_SecondSizeWindow)
function Lua_ArmyEquipPackWindow:ctor()
    self:superCall("ctor");
    self.resolveArr = Array();
    self.windowName = "Lua_ArmyEquipPackWindow";
    self.skinName = "ArmyEquipPackWindow_skin";
    self.titleText = LanUtil.getValue(140504);
end

function Lua_ArmyEquipPackWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose()
        self.dragList = nil;
    end

    if self.packArr ~= nil then
        self.packArr:clear();
        self.packArr = nil; 
    end
    DataCenter.armySoulData.isSelectPack = true;
    self:superCall("dispose");
end

function Lua_ArmyEquipPackWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 962, 458));
    self.dragList:setLocation(6, 4, 0);
    self.dragList:setListCell(Lua_ArmyEquipPackItem, 90, 97, 10);
  
    self.subBtn1:addClickFuntion(self, self.onSelectColorClick);   -- 选择类型
    self:setSelectType(DataCenter.armySoulData.select_type);

    self:addLuaEvent("PACK_ARMY_UPDATE", self, self.onUpdatePackInfo); -- 刷新背包
    self:onUpdatePackInfo();
end

function Lua_ArmyEquipPackWindow:onUpdatePackInfo()--背包数据
    local bagData = DataCenter.packData:getBagType(Lua_PackData.ARMY_PACK); --军魂 背包
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.ARMY_EQUIP_ITEM});
    local packArr = Array()
    local len = DataCenter.armySoulData.pack_size;
    for i=1,len do
        if arr[i] ~= nil then
        	local weight = 0;
            if DataCenter.armySoulData.isSelectPack == true then
                weight = 100000 + arr[i].color*1000 + (arr[i].part*-1);
            else
                if arr[i].isSameType == false then -- 不可穿戴
                    if arr[i].isShowItemReplaceRed == true then -- 可替换
                        weight = 200000 + arr[i].color * 1000 + (arr[i].part*-1);
                    else
                        weight = 100000 + arr[i].color * 1000 + (arr[i].part*-1);
                    end
                else
                    weight = 300000 + arr[i].color * 1000 + (arr[i].part*-1);
                end
            end

            if self.soulType ~= nil then
            	self:setSelectType(self.soulType+1)
        		if arr[i].soul_type == self.soulType then
            		packArr:add({data = arr[i], weight=weight});
                else
                    packArr:add({data = nil, weight=0});
            	end
        	else
	            if self.selectType == 1 then
	            	packArr:add({data = arr[i], weight=weight});
	            else
	            	if arr[i].soul_type == self.selectType-1 then
	            		packArr:add({data = arr[i], weight=weight});
                    else
                        packArr:add({data = nil, weight=0});
		            end
	            end
	        end
        else
            if self.soulType ~= nil then
                self:setSelectType(self.soulType+1);
            end
            packArr:add({data = nil, weight=0});
        end
    end
    -- print("长度   ",packArr:getSize())
    packArr:sort("weight", true);
    self.dragList:setLuaArrayData(packArr, false);

end

function Lua_ArmyEquipPackWindow:showWin(param)
	self:superCall("showWin", param);
	self.soulType = self.showData.soulType;
	self:onUpdatePackInfo();
end 

function Lua_ArmyEquipPackWindow:onSelectColorClick(go)
    local dragData = {};
    dragData.datas = Array();
    dragData.datas:add(LanUtil.getValue(140529));
    dragData.datas:add(LanUtil.getValue(140530));
    dragData.datas:add(LanUtil.getValue(140531));
    dragData.datas:add(LanUtil.getValue(140532));
    dragData.datas:add(LanUtil.getValue(140533));
    dragData.datas:add(LanUtil.getValue(140534));
    dragData.datas:add(LanUtil.getValue(140535));
    dragData.datas:add(LanUtil.getValue(140536));
    dragData.offsetX = 370;
    dragData.offsetY = -91;
    dragData.callBackOwner = self;
    dragData.callBack = self.onColorCallBack;
    dragData.selected = self.selectType;
    Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end


function Lua_ArmyEquipPackWindow:onColorCallBack(val)
    DataCenter.armySoulData.select_type = val;
    self.soulType = nil;
    self:setSelectType(val);
    self:onUpdatePackInfo();--背包数据
end

function Lua_ArmyEquipPackWindow:setSelectType(val)
    self.selectType = val;

    if val == 1 then        -- 全部
        self.subTxt1.text = LanUtil.getValue(140529);
        self.dic.text = LanUtil.getValue(140554);
    elseif val == 2 then    -- 一类
        self.subTxt1.text = LanUtil.getValue(140530);
        self.dic.text = LanUtil.getValue(140555);
    elseif val == 3 then    -- 二类
        self.subTxt1.text = LanUtil.getValue(140531);
        self.dic.text = LanUtil.getValue(140556);
    elseif val == 4 then    -- 三类
        self.subTxt1.text = LanUtil.getValue(140532);
        self.dic.text = LanUtil.getValue(140557);
    elseif val == 5 then    -- 四类
        self.subTxt1.text = LanUtil.getValue(140533);
        self.dic.text = LanUtil.getValue(140558);
    elseif val == 6 then    -- 五类
        self.subTxt1.text = LanUtil.getValue(140534);
        self.dic.text = LanUtil.getValue(140559);
    elseif val == 7 then    -- 六类
        self.subTxt1.text = LanUtil.getValue(140535);
        self.dic.text = LanUtil.getValue(140560);
    elseif val == 8 then    -- 七类
        self.subTxt1.text = LanUtil.getValue(140536);
        self.dic.text = LanUtil.getValue(140561);
    end
end
























Lua_ArmyEquipPackItem = class("Lua_ArmyEquipPackItem", Lua_ListCell);
function Lua_ArmyEquipPackItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_ArmyEquipPackItem:buildShowItem()
    self:superCall("buildShowItem");
    if self.itemImage == nil then
        self.itemImage = Lua_ToolImage.new(self.content);
        self.itemImage:setDepth(5);
        self.itemImage:setLocation(0,6,0);
        self.itemImage:setCanClick(false);
    end
end

function Lua_ArmyEquipPackItem:setData(data)
    self.data = data.data;
    self.itemImage.data = self.data;
    if DataCenter.armySoulData.isSelectPack == true then
        self.itemImage:showBetterTip(0);
    end
end

function Lua_ArmyEquipPackItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data,false,nil,true);
	end
end
function Lua_ArmyEquipPackItem:checkOutBound(showRect)
    if self.data == nil then
        self.inViewEffect = false;
        return;
    end
    local rect = Lua_Rectangle.new(self.itemX - 40, self.itemY - 24, 70,60);
    if showRect:containeRect(rect) == true then
        self.inViewEffect = true;
    else
        self.inViewEffect = false;
    end
    self:updateEffectState();
end

function Lua_ArmyEquipPackItem:updateEffectState()
    if self.inViewEffect == true then
        if self.itemImage.armyEff == nil then
            self.itemImage:showRoundEff(true);
        end
    else
        self.itemImage:showRoundEff(false);
    end
end

function Lua_ArmyEquipPackItem:dispose()
    self:superCall("dispose");
end