--魂印分解

Lua_ArmyEquipResolveWindow = class("Lua_ArmyEquipResolveWindow", Lua_SecondSizeWindow)
function Lua_ArmyEquipResolveWindow:ctor()
    self:superCall("ctor");
    self.resolveArr = Array();
    self.windowName = "Lua_ArmyEquipResolveWindow";
    self.skinName = "ArmyEquipResolveWindow_skin";
    self.titleText = LanUtil.getValue(140505);
end

function Lua_ArmyEquipResolveWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 962, 436));
    self.recordsList:setLocation(6, 16, 0);
    self.recordsList:setListCell(Lua_ArmyEquipResolveItem, 90, 97, 10);
    
    self.num_sprit1:setAltas("item10", "216000004");
    self.num_sprit1.clickScale = false;
    self.num_sprit1:addClickFuntion(self, self.onOpenOenTips);

    self.num_sprit2:setAltas("item10", "216000003");
    self.num_sprit2.clickScale = false;
    self.num_sprit2:addClickFuntion(self, self.onOpenTwoTips);

    self.num_sprit3:setAltas("item10", "216000002");
    self.num_sprit3.clickScale = false;
    self.num_sprit3:addClickFuntion(self, self.onOpenThreeTips);

    self.num_sprit4:setAltas("item10", "216000001");
    self.num_sprit4.clickScale = false;
    self.num_sprit4:addClickFuntion(self, self.onOpenFourTips);

    self.help:addClickFuntion(self, self.onHelpClick);
    self.resolveBtn:addClickFuntion(self, self.onResolveClick);
    self.subBtn1:addClickFuntion(self, self.onSelectColorClick);   -- 选择分解类型
    self:setSelectType(DataCenter.armySoulData.resolve_color-1);
    
    self:onUpdatePackInfo();
    self:addLuaEvent("UPDATE_ARMY_SELCET", self, self.onSelectArmyInfo);
    self:addLuaEvent("UPDATE_ARMY_INFO", self, self.onUpdatePackInfo);
    self:addLuaEvent("PACK_ARMY_UPDATE", self, self.onUpdatePackInfo); -- 更新背包数据
end

function Lua_ArmyEquipResolveWindow:onUpdatePackInfo()--背包数据
    local bagData = DataCenter.packData:getBagType(Lua_PackData.ARMY_PACK); --军魂 背包
    local arr = bagData:getItemsBySubType({Lua_PackTypeDefine.ARMY_EQUIP_ITEM});
    
    self.resolveList = Array()
    local len = DataCenter.stampUtil.pack_size;
    for i=1,len do
        if arr[i] ~= nil then
            local weight = 100000 + arr[i].color*1000 + (arr[i].part*-1);
            self.resolveList:add({vo = arr[i], isSelect = self:checkSelect(arr[i]), weight=weight});
        else
            self.resolveList:add({vo = nil, isSelect = false, weight=0});
        end
    end
    self.resolveList:sort("weight", true);
    self.recordsList:setLuaArrayData(self.resolveList, false);

    self:onResolveEquipData();
end

function Lua_ArmyEquipResolveWindow:onSelectArmyInfo()--点击 单个灵纹 刷新界面
    self:onResolveEquipData();
    self:updateSelect();
end

function Lua_ArmyEquipResolveWindow:checkSelect(vo)
    if vo == nil then
        return false;
    end
    
    if self.selectType == 1 and vo.color <= 2 then
        return true;
    elseif self.selectType == 2 and vo.color <= 3 then
        return true;
    elseif self.selectType == 3 and vo.color <= 4 then
        return true;
    elseif self.selectType == 4 and vo.color <= 5  then
        return true;
    -- elseif self.selectType == 6 and vo.color <= 6  then
    --     return true;
    end

    return false;
end

function Lua_ArmyEquipResolveWindow:onResolveEquipData()--分解数据
    self.resolveArr:clear();
    local len = self.resolveList:getSize();
    for i=1,len do
        if self.resolveList[i].isSelect == true then
            local list  = {};
            list.index = self.resolveList[i].vo.index;
            list.id = self.resolveList[i].vo.id;
            list.count = self.resolveList[i].vo.count;
            list.color = self.resolveList[i].vo.color;
            list.decomposeId = self.resolveList[i].vo.decomposeItem.id;
            list.decompose = self.resolveList[i].vo.decompose;
            self.resolveArr:add(list);      
        end
    end
    local color = "[192e41]";
    local color1 = "[13a100]";
    if self.resolveArr:getSize() > 0  then
        self.numTxt1.text = color.. DataCenter.armySoulData.army_pink.."[-]"..color1.."+"..DataCenter.armySoulData:cloakResolveNum(self.resolveArr,216000004);
        self.numTxt2.text = color.. DataCenter.armySoulData.army_red.."[-]"..color1.."+"..DataCenter.armySoulData:cloakResolveNum(self.resolveArr,216000003);
        self.numTxt3.text = color.. DataCenter.armySoulData.army_orange.."[-]"..color1.."+"..DataCenter.armySoulData:cloakResolveNum(self.resolveArr,216000002);
        self.numTxt4.text = color.. DataCenter.armySoulData.army_purple.."[-]"..color1.."+"..DataCenter.armySoulData:cloakResolveNum(self.resolveArr,216000001);
    else
        self.numTxt1.text = color.. DataCenter.armySoulData.army_pink;
        self.numTxt2.text = color.. DataCenter.armySoulData.army_red;
        self.numTxt3.text = color.. DataCenter.armySoulData.army_orange;
        self.numTxt4.text = color.. DataCenter.armySoulData.army_purple;
    end

    self:updateEquipResolveRed()--红点显示
end

function Lua_ArmyEquipResolveWindow:onSelectColorClick(go)
    local dragData = {};
    dragData.datas = Array();
    dragData.datas:add(LanUtil.getValue(124424));
    dragData.datas:add(LanUtil.getValue(124425));
    dragData.datas:add(LanUtil.getValue(124426));
    dragData.datas:add(LanUtil.getValue(124427));
    --dragData.datas:add(LanUtil.getValue(140542));
    dragData.offsetX = -364;
    dragData.offsetY = -55;
    dragData.callBackOwner = self;
    dragData.callBack = self.onColorCallBack;
    dragData.selected = self.selectType;
    Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_ArmyEquipResolveWindow:onColorCallBack(val)
    DataCenter.stampData.select_color = val;
    self:setSelectType(val);
    self:onUpdatePackInfo();--背包数据
    self:onResolveEquipData();
end

function Lua_ArmyEquipResolveWindow:setSelectType(val)
    self.selectType = val;

    if val == 1 then    --蓝色
        self.subTxt1.text = LanUtil.getValue(124418);
    elseif val == 2 then    --紫色
        self.subTxt1.text = LanUtil.getValue(124419);
    elseif val == 3 then    --橙色
        self.subTxt1.text = LanUtil.getValue(124420);
    elseif val == 4 then    --红色
        self.subTxt1.text = LanUtil.getValue(124421);
    -- elseif val == 6 then    --粉色
    --     self.subTxt1.text = LanUtil.getValue(140543);
    end
end

function Lua_ArmyEquipResolveWindow:onResolveTipsClick()
    local tipData = {};
    tipData.des = LanUtil.getValue(140549)
    tipData.owner = self;
    tipData.type = 1;
    tipData.subFun = self.onSubCallback;
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_ArmyEquipResolveWindow:onResolveClick()
    local isResolve = false;
    local len = self.resolveArr:getSize()
    if len > 0 then
         for i=1,len do
            if self.resolveArr[i].type ~= 0 then
                if self.resolveArr[i].color >= 4 then
                    isResolve = true;
                end
            end
        end
        if isResolve == true then
            self:onResolveTipsClick();
        else
            self:onSubCallback();
        end
    else
        OperateAlert.show(LanUtil.getValue(128549));
    end
end

function Lua_ArmyEquipResolveWindow:onSubCallback()
    Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sResolveArmyEquip(self.resolveArr);
    if self.resolveList ~= nil then
        self.resolveList:clear();
    end

    if self.resolveArr ~= nil then
        self.resolveArr:clear();
    end
end

function Lua_ArmyEquipResolveWindow:updateSelect()
    if self.recordsList ~= nil then
        local arr = self.recordsList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateSelect();
        end
    end
end

function Lua_ArmyEquipResolveWindow:updateEquipResolveRed() --红点更新
    local isShowResolveRed = DataCenter.armySoulData:isShowEquipResolveRed();
    if isShowResolveRed == true then
        self:showRedDot(true);--分解红点显示
    else
        self:showRedDot(false);
    end
end

function Lua_ArmyEquipResolveWindow:showRedDot(val)--红点显示
    if val == true then
        if self._redDotIcon == nil then
            self._redDotIcon = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot",500,-264, 0, 0);
            self._redDotIcon:setDepth(7);
            self._redDotIcon.name = "redDotIcon1";
        end
        self._redDotIcon:setEnable(true);
    else
        if self._redDotIcon ~= nil then
            self._redDotIcon:setEnable(false);
        end
    end
end

function Lua_ArmyEquipResolveWindow:onOpenOenTips()
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(216000004),false)
end

function Lua_ArmyEquipResolveWindow:onOpenTwoTips()
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(216000003),false)
end

function Lua_ArmyEquipResolveWindow:onOpenThreeTips()
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(216000002),false)
end

function Lua_ArmyEquipResolveWindow:onOpenFourTips()
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(216000001),false)
end

function Lua_ArmyEquipResolveWindow:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(140510));
end

function Lua_ArmyEquipResolveWindow:dispose()
    if self.recordsList ~= nil then
        self.recordsList:dispose()
        self.recordsList = nil;
    end
    if self.resolveList ~= nil then
        self.resolveList:clear();
        self.resolveList = nil; 
    end
    if self.resolveArr ~= nil then
        self.resolveArr:clear();
        self.resolveArr = nil; 
    end
    self:superCall("dispose");
end

















Lua_ArmyEquipResolveItem = class("Lua_ArmyEquipResolveItem", Lua_ListCell);
function Lua_ArmyEquipResolveItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_ArmyEquipResolveItem:buildShowItem()
    self:superCall("buildShowItem");
    if self.itemImage == nil then
        self.itemImage = Lua_ToolImage.new(self.content);
        self.itemImage:setDepth(3);
        self.itemImage:setLocation(0,6,0);
        self.itemImage:setCanClick(false);
    end
end

 function Lua_ArmyEquipResolveItem:setData(data)
    self.data = data;
    self.vo = data.vo;
    self.itemImage.data = self.vo;
    self:updateSelect();
 end

function Lua_ArmyEquipResolveItem:updateSelect()
    if self.data.isSelect == true then
        if self.shade == nil then
            self.shade = UICreate.createUIAtlasImage(self.content, "iconantlas1", "tick_green", 0, 6, 0, 0);
            self.shade:setDepth(10);
        end
        self.shade:setEnable(true);
        self.itemImage:setGray(true);
    else
        if self.shade ~= nil then
            self.shade:setEnable(false);
        end
        
        self.itemImage:setGray(false);
    end
end

function Lua_ArmyEquipResolveItem:checkOutBound(showRect)
    if self.data == nil or self.vo == nil then
        self.inViewEffect = false;
        return;
    end
    local rect = Lua_Rectangle.new(self.itemX - 40, self.itemY - 24, 70,60);
    if showRect:containeRect(rect) == true then
        self.inViewEffect = true;
    else
        self.inViewEffect = false;
    end
    self:updateEffectState();
end

function Lua_ArmyEquipResolveItem:updateEffectState()
    if self.inViewEffect == true then
        if self.itemImage.armyEff == nil then
            self.itemImage:showRoundEff(true);
        end
    else
        self.itemImage:showRoundEff(false);
    end
end

function Lua_ArmyEquipResolveItem:onPlayerSoundClick(go)
    if self.vo ~= nil then
        if self.data.isSelect == true then
            self.data.isSelect = false;
        else
            self.data.isSelect = true;
        end
        Lua_MsgUtil.callFunc("UPDATE_ARMY_SELCET");
    end
end

function Lua_ArmyEquipResolveItem:dispose()
    self:superCall("dispose");
end