-- 军魂装备
checkRequire("Lua_ArmyEquipItem");
checkRequire("Lua_ArmySkillItem");
Lua_ArmyEquipWindow = class("Lua_ArmyEquipWindow", Lua_SecondSizeWindow)
function Lua_ArmyEquipWindow:ctor()
    self:superCall("ctor");

	self.isModel = true;
    self.windowName = "Lua_ArmyEquipWindow";
    self.skinName = "ArmyEquipWindow_skin";
	self.titleText = LanUtil.getValue(140503);
end

function Lua_ArmyEquipWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.num_sprit1:setAltas("item10", "216000004");
    self.num_sprit1.clickScale = false;
    self.num_sprit1:addClickFuntion(self, self.onOpenOenTips);

    self.num_sprit2:setAltas("item10", "216000003");
    self.num_sprit2.clickScale = false;
    self.num_sprit2:addClickFuntion(self, self.onOpenTwoTips);

    self.num_sprit3:setAltas("item10", "216000002");
    self.num_sprit3.clickScale = false;
    self.num_sprit3:addClickFuntion(self, self.onOpenThreeTips);

    self.num_sprit4:setAltas("item10", "216000001");
    self.num_sprit4.clickScale = false;
    self.num_sprit4:addClickFuntion(self, self.onOpenFourTips);

    local poses = {{-141,-86},{-48,-172},{76,-172},{169,-86}};
    self.itemArr = Array();
    for i, v in ipairs(poses) do
        local item = Lua_ArmyEquipItem.new(self.content);--左槽
        item:setLocation(v[1], v[2], 0);
        item:setDepth(10);
        item:setCanClick(true);
        item:setEquipNnmetype(i);
        self.itemArr:add(item);
    end

    self:addLuaEvent("SELECT_ARMY_EQUIP_ITEM", self, self.onUpSelectItemClick);-- 点击Item
    self:addLuaEvent("SHOW_SELECT_ITEM", self, self.onSelectEquipItem);       -- 点击魂装
    self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 250, 468));
    self.dragList:setLocation(-370, -1, 0);
    self.dragList:setListCell(Lua_ArmySoulEquipItem, 115, 252, 1);
    self.help:addClickFuntion(self, self.onHelpClick);
    self.packBtn:addClickFuntion(self, self.onPackBtnClick);        -- 背包
    self.resolveBtn:addClickFuntion(self, self.onResolveBtnClick);  -- 分解
    self.upgradeBtn:addClickFuntion(self, self.onUpgradeBtnClick);  -- 升阶
    
    Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sOpenArmyPanelInfo();
    self:addLuaEvent("UPDATE_ARMY_INFO", self, self.updateArmyEquipPanel);
    self:addLuaEvent("PACK_ARMY_UPDATE",self, self.updateArmyEquipPanel);
    self:updateArmyEquipPanel();
end

-- 更新背包数据
function Lua_ArmyEquipWindow:updateArmyEquipPanel()
    
    self.numTxt1.text = DataCenter.armySoulData.army_pink;
    self.numTxt2.text = DataCenter.armySoulData.army_red;
    self.numTxt3.text = DataCenter.armySoulData.army_orange;
    self.numTxt4.text = DataCenter.armySoulData.army_purple;

    local arr = DataCenter.armySoulData.armyArr;
    local select_index = DataCenter.armySoulData.selectEqpIndex;
    local select_id = DataCenter.armySoulData.selectEqpId;
    self.dragList:setLuaArrayData(arr, false);
    self.dragList:setSelected(select_index);

    if select_id == nil then
        self.dragList.showList[select_index]:onPlayerSoundClick();
    else
        local info  = DataCenter.armySoulData:getArrByArmyInfo(select_id);
        self:onUpSelectItemClick(info);
    end

    if DataCenter.armySoulData:isShowEquipResolveRed() == true then
        self.resolveRed:setEnable(true);
    else
        self.resolveRed:setEnable(false);
    end
end

function Lua_ArmyEquipWindow:onUpSelectItemClick(data)--选择Item
	self.data = data;
    self.nameTxt.text = data.army_name;
    self.prop_base.text = data.armyEquipProp; -- 装备属性
    local item_info = data.armyEquipInfo;
    for k,v in pairs(item_info) do
        if v.part ~= nil then
            self.itemArr[v.part]:setEquipInfo(v);
            self.itemArr[k].select:setEnable(false);
        end
    end

    if data.activate == 0 then
        self.subObg:SetActive(true);
        self.upgradeBtn.mainContent:SetActive(false);
        self.lvl_bg:setEnable(false);
        self.lvl_text.uiwidget.gameObject:SetActive(false);
    else
        self.subObg:SetActive(false);
        self.upgradeBtn.mainContent:SetActive(true);
        self.lvl_bg:setEnable(true);
        self.lvl_text.uiwidget.gameObject:SetActive(true);
        self.lvl_text.text = LanUtil.formateStr(LanUtil.getValue(140517),tostring(data.lvl));
    end

    if data.isEquipOrderRed ~= nil then
        self.orderRed:setEnable(true);
    else
        self.orderRed:setEnable(false);
    end

    self:createSkillItem();
    self:showArmyModel();--创建模型
end

function Lua_ArmyEquipWindow:onSelectEquipItem(part)-- 点击魂装
    local item_info = self.data.armyEquipInfo;
    for k,v in pairs(item_info) do
        if v.id ~= 0 then
            if v.part == part then
                self.itemArr[k].select:setEnable(true);
            else
                self.itemArr[k].select:setEnable(false);
            end
        end
    end
end

function Lua_ArmyEquipWindow:createSkillItem()
    local arr = self.data.armySkillInfo;
    if self.skillArr == nil then
        self.skillArr = Array();
        local poses = {{335,-90},{435,-90},{335,-190},{435,-190}};
        local index = 0;
        for i=1, arr:getSize() do
            if arr[i].skill_class == 2 then
                index = index +1;
                local item = Lua_ArmySkillItem.new(self.content);--左槽
                item:setLocation(poses[index][1], poses[index][2], 0);
                item:setCanClick(true);
                item:setSkillInfo(arr[i]);
                self.skillArr:add(item);
            end
        end
    else
        local index = 0;
        for i=1, arr:getSize() do
            if arr[i].skill_class == 2 then
                index = index +1;
                self.skillArr[index]:setSkillInfo(arr[i]);
            end
        end
    end
end

function Lua_ArmyEquipWindow:showArmyModel()
    local shapeConfig = self.data.shapeConfig;
    if shapeConfig == nil then 
        return print("not_Model");
    end
    self.floder = shapeConfig.floder;
    self.fileName = shapeConfig.fileName;
    self.modelName = shapeConfig.modelName;

    if self._modelEffect ~= nil then
        self._modelEffect:dispose()
    end

    local modelpos = self.data.modelpos;
    local modelros = self.data.modelros;
    local modelsca =self.data.modelsca;

    self._modelEffect = UIModelTexture();
    
    local imgPos = Vector2(15, 10);
    local imgSize = Vector2(1175, 680);
    local modelRot = Vector3(0, 180, 0);
    local modelOffset = Vector2(-265, -250);

    self._modelEffect:init(self.content,imgPos,imgSize,3,modelRot,modelOffset,160);
    self._modelEffect:setCamPos(-10000,0,0);
    self._modelEffect:setModelOffset(modelpos[1],modelpos[2],modelpos[3]);
    self._modelEffect:setRotEnable(false,0, 0, 300, 400, 2)
    if self.data.activate == 0 then
        self._modelEffect.uiEffect:setGray(true);
    else
        self._modelEffect.uiEffect:setGray(false);
    end

    self._modelEffect:setModelAngle(modelros[1],modelros[2],modelros[3]);
    self._modelEffect:setCamView(15);
    self._modelEffect.uiEffect:setSacle(modelsca[1],modelsca[2],modelsca[3])
    self._modelEffect:setUrl(self.floder.."/"..self.fileName,self.modelName)
end

function Lua_ArmyEquipWindow:onUpgradeBtnClick()-- 升阶
    if self.data.isOpenUpgrade ~= nil then
        Lua_WindowUtil.openWin("Lua_ArmyUpgradeWindow",WinParam.ACTION_OPEN,self.data.army_id)
    else
        OperateAlert.show(LanUtil.getValue(140518));
    end
end

function Lua_ArmyEquipWindow:onPackBtnClick()-- 背包
    DataCenter.armySoulData.isSelectPack = true;
    Lua_WindowUtil.openWin("Lua_ArmyEquipPackWindow",WinParam.ACTION_OPEN)
end

function Lua_ArmyEquipWindow:onResolveBtnClick()-- 分解
    Lua_WindowUtil.openWin("Lua_ArmyEquipResolveWindow",WinParam.ACTION_OPEN)
end

function Lua_ArmyEquipWindow:onOpenOenTips()
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(216000004),false)
end

function Lua_ArmyEquipWindow:onOpenTwoTips()
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(216000003),false)
end

function Lua_ArmyEquipWindow:onOpenThreeTips()
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(216000002),false)
end

function Lua_ArmyEquipWindow:onOpenFourTips()
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(216000001),false)
end

function Lua_ArmyEquipWindow:onHelpClick()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(140508));
end

function Lua_ArmyEquipWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose()
        self.dragList = nil;
    end
    if self.itemArr ~= nil then
        for i=1,self.itemArr:getSize() do
            self.itemArr[i]:dispose();
        end
    end
    DataCenter.armySoulData.selectEqpIndex = 1;
    DataCenter.armySoulData.selectEqpId = nil;
    self:superCall("dispose");
end





























Lua_ArmySoulEquipItem = class("Lua_ArmySoulEquipItem", Lua_ListCell);
function Lua_ArmySoulEquipItem:ctor(p)
    self:superCall("ctor", p, "ArmySoulEquipItem_skin");
end

function Lua_ArmySoulEquipItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_ArmySoulEquipItem:setData(data)
	self.data = data;
    self.name.text = data.item_name;
    self.lvl.text = data.item_lvl;
    self.icon_bg:setAltas("iconantlas1", data.icon_bg);
    self.icon:setAltas("armySoul", tostring("army_"..data.index));

    if data.activate == 0 then
        self.icon_bg:setGray(true);
        self.icon:setGray(true);
    else
        self.icon_bg:setGray(false);
        self.icon:setGray(false);
    end

    if data.isShowEquipItmeRed == true then
        self.red:setEnable(true);
    else
        self.red:setEnable(false);
    end
end

function Lua_ArmySoulEquipItem:onPlayerSoundClick(go)
    DataCenter.armySoulData.selectEqpIndex = self.data.index;
    DataCenter.armySoulData.selectEqpId = self.data.army_id;
	Lua_MsgUtil.callFunc("SELECT_ARMY_EQUIP_ITEM", self.data);
end

function Lua_ArmySoulEquipItem:onSelectionChange(val)
    self:superCall("onSelectionChange", val);
    if self.bg ~= nil then
        if val == true then
            self.bg:setAltas("awakeWindow", "awake_select");
        else
            self.bg:setAltas("awakeWindow", "awake_normal");
        end
    end
end

function Lua_ArmySoulEquipItem:dispose()
    self:superCall("dispose");
end