-- 军魂系统
checkRequire("Lua_ArmySkillItem");
checkRequire("Lua_ArmyPropItem");
Lua_ArmySoulPanel = class("Lua_ArmySoulPanel", Lua_DisplayObject);
function Lua_ArmySoulPanel:ctor(p)
	self:superCall("ctor", p, "ArmySoulPanel_skin");
	self.isAutomatic = true;
end

function Lua_ArmySoulPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.exeObg:SetActive(false);
	self.subObg:SetActive(false);
	self.equipRed:setEnable(false);
	self.subBtn:setEnable(false);

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(320, 245, 0);

	self.image = Lua_ToolImage.new(self.content);
	self.image:setDepth(6);
	self.image:setLocation(275,-294,0);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 296, 592));
	self.dragList:setListCell(Lua_ArmySoulItem, 115, 306, 1);
	self.dragList:setLocation(-475, -27, 0);

	self.subBtn:addClickFuntion(self, self.onSubAutoClick); -- 提升
	self.equipBtn:addClickFuntion(self, self.onEquipBtnClick); -- 军魂装备
	self.activateBtn:addClickFuntion(self, self.onActivateBtnClick); -- 激活

	self:addLuaEvent("UPDATE_ARMY_ITEM", self, self.onUpSelectItemClick); -- 点击Item
	self:addLuaEvent("UPDATE_ARMY_INFO", self, self.updateArmyPanel);
	self:addLuaEvent("PACK_ARMY_UPDATE",self, self.updateArmyPanel);
	self:addLuaEvent("UPDATE_INTENS_ARMY", self, self.onSuccessEvent); --特效
	Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sOpenArmyPanelInfo();
end

-- 更新数据
function Lua_ArmySoulPanel:updateArmyPanel()
	local arr = DataCenter.armySoulData.armyArr;
	local select_index = DataCenter.armySoulData.selectIndex;
	local select_id = DataCenter.armySoulData.selectId;
	self.dragList:setLuaArrayData(arr, false);
	self.dragList:setSelected(select_index);
	if select_id == nil then
		self.dragList.showList[select_index]:onPlayerSoundClick();
	else
		local info = DataCenter.armySoulData:getArrByArmyInfo(select_id);
		self:onUpSelectItemClick(info);
	end

	if DataCenter.armySoulData:isShowOpenEquipRed() or DataCenter.armySoulData:isShowEquipResolveRed() then
		self.equipRed:setEnable(true);
	else
		self.equipRed:setEnable(false);
	end
end

function Lua_ArmySoulPanel:onUpSelectItemClick(data)
	self.data = data;

	self.nameTxt.text = data.army_name;
	self.fightNum.num = data.armyBaseForce;

	if data.activate == 0 then
		self.image.data = data.activation_cost;
		self.image:showNumLimit(data.activation_cost.bagNum, data.activation_cost.needNum, 2);
		self.image:setEnable(true);

		self.tips1.text = LanUtil.getValue(140501);
		self.tips2.text = LanUtil.formateStr(LanUtil.getValue(140502),tostring(data.activate_lvl));

		self.subObg:SetActive(true);
		self.exeObg:SetActive(false);
		self.lvl_bg:setEnable(false);
		self.lvl_text:setEnable(false);
		self.subBtn:setEnable(false);
		self.tips3:setEnable(false);
	else
		self.lvl_text.text = LanUtil.formateStr(LanUtil.getValue(140517),tostring(data.lvl));

		if data.isMaxUpgradeLvl == true then -- 是否达到最大等级
			local num = LanUtil.formateStr(LanUtil.getValue(128548),tostring(data.schedule));
			self.subBar:setText(num);
			self.subBar:setMaxValue(data.upgrade_num);
			self.subBar:setValue(data.schedule);
			
			self.tips3.text = LanUtil.getValue(140538);
			self.tips3:setLocation(250, -295, 0)
			
			self.image:setEnable(false);
			self.subBtn:setBtnEnable(false);
		else
			self.subBar:setText(data.schedule.."/"..data.upgrade_num);
			self.subBar:setMaxValue(data.upgrade_num);
			self.subBar:setValue(data.schedule);

			self.tips3.text = LanUtil.getValue(140528);
			self.tips3:setLocation(128, -295, 0)

			self.image.data = data.upgrade_cost;
			self.image:showNumLimit(data.upgrade_cost.bagNum, data.upgrade_cost.needNum, 2);
			self.image:setEnable(true);
			self.subBtn:setBtnEnable(true);
		end

		self.subObg:SetActive(false);
		self.exeObg:SetActive(true);
		self.lvl_bg:setEnable(true);
		self.lvl_text:setEnable(true);
		self.subBtn:setEnable(true);
		self.tips3:setEnable(true);
	end
	self.red:setEnable(data.isShowBtnRed);

	if DataCenter.armySoulData.isAutomatic == false then --移除自动强化计时器
		self.isAutomatic = false;
		self:onSubAutoClick();
	end

	self:createSkillItem();
	self:createPropItem();
	self:showArmyModel();
end

function Lua_ArmySoulPanel:createSkillItem()
	local arr = self.data.armySkillInfo;
	if self.skillArr == nil then
		self.skillArr = Array();

		local item;
		local pos = {360, -133};
		for i = 1, arr:getSize() do
			if arr[i].skill_class == 1 then
				item = Lua_ArmySkillItem.new(self.content); -- 左槽
				item:setCanClick(true);
				item:setSkillInfo(arr[i]);
				item:setLocation(pos[1], pos[2], 0);
				self.skillArr:add(item);
			end
		end
	else
		for i = 1, arr:getSize() do
			if arr[i].skill_class == 1 then
				self.skillArr[1]:setSkillInfo(arr[i]);
			end
		end
	end
end

function Lua_ArmySoulPanel:createPropItem()
	local arr = self.data.armyBaseProp;
	if self.propArr == nil then
		self.propArr = Array();

		local item;
		for i = 1, arr:getSize() do
			item = Lua_ArmyPropItem.new(self.content);
			item:setPropNnmetype(i);
			item:setValue(arr[i]);
			item:setLocation(220, 170 - i * 35, 0);
			self.propArr:add(item);
		end
	else
		for i = 1, arr:getSize() do
			self.propArr[i]:setValue(arr[i]);
		end
	end
end

function Lua_ArmySoulPanel:showArmyModel()
	local shapeConfig = self.data.shapeConfig;
	if shapeConfig == nil then 
		return print("not_Model");
	end

	local imgPos = Vector2(-50, 10);
	local imgSize = Vector2(1175, 680);
	local modelRot = Vector3(0, 180, 0);
	local modelOffset = Vector2(-265, -250);
	local modelpos = self.data.modelpos;
	local modelros = self.data.modelros;
	local modelsca =self.data.modelsca;

	if self._modelEffect ~= nil then
		self._modelEffect:dispose();
	end
	self._modelEffect = UIModelTexture();
	self._modelEffect:init(self.content, imgPos, imgSize, 3, modelRot, modelOffset, 160);
	self._modelEffect:setCamPos(10000, 0, 0);
	self._modelEffect:setCamView(15);
	self._modelEffect:setModelOffset(modelpos[1], modelpos[2], modelpos[3]);
	self._modelEffect:setModelAngle(modelros[1], modelros[2], modelros[3]);
	self._modelEffect.uiEffect:setSacle(modelsca[1], modelsca[2], modelsca[3]);
	self._modelEffect:setUrl(shapeConfig.floder.."/"..shapeConfig.fileName, shapeConfig.modelName);
	if self.data.activate == 0 then
		self._modelEffect.uiEffect:setGray(true);
		self._modelEffect:setRotEnable(false, 0, 0, 300, 400, 2);
	else
		self._modelEffect.uiEffect:setGray(false);
		self._modelEffect:setRotEnable(true, 0, 0, 300, 400, 2);
	end
end

function Lua_ArmySoulPanel:onSuccessEvent()
	if self.effect1 == nil then
		self.effect1 = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_shengjichenggong", "gui_shengjichenggong", -55, -160);
		self.effect1:SetRenderQueue(self.sub_bg, 100, 2,false);
	end
	self.effect1:setEnable(false);
	self.effect1:setEnable(true);
end

-- 军魂装备
function Lua_ArmySoulPanel:onEquipBtnClick()
	self.isAutomatic = false;
	self:onSubAutoClick(); -- 自动强化
	Lua_WindowUtil.openWin("Lua_ArmyEquipWindow",WinParam.ACTION_OPEN)
end

-- 激活
function Lua_ArmySoulPanel:onActivateBtnClick()
	if self.data.isCanActivate == true then
		if self.data.isShowBtnRed == true then
			Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sActivateArmySoul(self.data.army_id);
		else
			OperateAlert.show(LanUtil.getValue(140521));
		end
	else
		OperateAlert.show(LanUtil.getValue(140527));
	end
end

-- 自动提升
function Lua_ArmySoulPanel:onSubAutoClick()
	if self.isAutomatic == true then
		DataCenter.armySoulData.isAutomatic = self.isAutomatic;

		self.isAutomatic = false;
		Lua_CommonUtil.addTimer("auto_Army_Timer", 0.3, self, self.onArmySubClick);

		self.subBtn.label = LanUtil.getValue(124134);
	else
		self.isAutomatic = true;
		Lua_CommonUtil.removeTimer(self, self.onArmySubClick);

		self.subBtn.label = LanUtil.getValue(124133);
	end
end

-- 强化
function Lua_ArmySoulPanel:onArmySubClick(go)
	if self.data.isShowBtnRed == true then
		self:onAffirmCombineClick();
	else
		if self.data.isMaxUpgradeLvl == true then
			OperateAlert.show(LanUtil.getValue(140552));
		else
			OperateAlert.show(LanUtil.getValue(140553));
		end
		self.isAutomatic = false;
		self:onSubAutoClick(); -- 自动强化
		return;
	end
end

function Lua_ArmySoulPanel:onAffirmCombineClick()
	Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sPromoteArmySoul(self.data.army_id);
end

function Lua_ArmySoulPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	DataCenter.armySoulData.selectId = nil;
	DataCenter.armySoulData.selectIndex = 1;
	Lua_CommonUtil.removeTimer(self, self.onArmySubClick);

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ArmySoulItem = class("Lua_ArmySoulItem", Lua_ListCell);
function Lua_ArmySoulItem:ctor(p)
	self:superCall("ctor", p, "ArmySoulPanelItem_skin");
end

function Lua_ArmySoulItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ArmySoulItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.lvl.text = data.item_lvl;
	self.name.text = data.item_name;
	self.icon_bg:setAltas("iconantlas1", data.icon_bg);
	self.icon:setAltas("armySoul", tostring("army_"..data.index));

	self.icon_bg:setGray(data.activate == 0);
	self.icon:setGray(data.activate == 0);
	self.red:setEnable(data.isShowBtnRed);
end

function Lua_ArmySoulItem:onPlayerSoundClick(go)
	DataCenter.armySoulData.selectIndex = self.data.index;
	DataCenter.armySoulData.selectId = self.data.army_id;
	DataCenter.armySoulData.isAutomatic = false;
	Lua_MsgUtil.callFunc("UPDATE_ARMY_ITEM", self.data);
end

function Lua_ArmySoulItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.bg:setAltas("awakeWindow", "awake_select");
	else
		self.bg:setAltas("awakeWindow", "awake_normal");
	end
end

function Lua_ArmySoulItem:dispose()
    self:superCall("dispose");
end