-- 升阶
checkRequire("Lua_ArmyEquipItem");
Lua_ArmyUpgradeWindow = class("Lua_ArmyUpgradeWindow", Lua_SecondSizeWindow)
function Lua_ArmyUpgradeWindow:ctor()
    self:superCall("ctor");

	self.isModel = true;
    self.windowName = "Lua_ArmyUpgradeWindow";
    self.skinName = "ArmyUpgradeWindow_skin";
	self.titleText = LanUtil.getValue(140503);
end

function Lua_ArmyUpgradeWindow:buildShowItem()
    self:superCall("buildShowItem");

    if self.image == nil then
        self.image = Lua_ToolImage.new(self.sprObg);
        self.image:setDepth(6);
        self.image:setScale(0.8,0.8,0.8);
        self.image:setLocation(370,-225,0);
    end

    local poses = {{-332,22},{-209,-43},{-79,-43},{44,22}};
    self.itemArr = Array();
    for i, v in ipairs(poses) do
        local item = Lua_ArmyEquipItem.new(self.content);--左槽
        item:setLocation(v[1], v[2], 0);
        item:setDepth(10);
        item:setUngardeClick(true);
        item:setEquipNnmetype(i);
        self.itemArr:add(item);
    end
    self:addLuaEvent("SHOW_ORDER_ITEM", self, self.onSelectEquipItem);       -- 点击魂装
    self.subBtn:addClickFuntion(self, self.onUpgradeBtnClick);  -- 升阶
    self:addLuaEvent("UPDATE_ARMY_INFO", self, self.updateArmyUpgradePanel);
    self:addLuaEvent("PACK_ARMY_UPDATE", self, self.updateArmyUpgradePanel);
end

-- 更新数据
function Lua_ArmyUpgradeWindow:updateArmyUpgradePanel()
	self.data = DataCenter.armySoulData:getArrByArmyInfo(self.army_id);
    self.name_text.text = self.data.army_name;
    self.add_prop.text = self.data.armyOrderProp;

    for k,v in pairs(self.data.armyEquipInfo) do
        if v.part ~= nil then
            self.itemArr[v.part]:setEquiplOrderInfo(v);
            self.itemArr[k].select:setEnable(false);
            if self.data.isEquipOrderRed ~= nil then
                if DataCenter.armySoulData.orderPart == nil then
                    if v.part == self.data.isEquipOrderRed then
                        self.itemArr[v.part]:onUpgardeClick();
                    end
                else
                    if v.part == DataCenter.armySoulData.orderPart then
                        self.itemArr[v.part]:onUpgardeClick();
                    end
                end
            else
                if self.data.isOpenUpgrade ~= nil then
                    if DataCenter.armySoulData.orderPart == nil then
                        if v.part == self.data.isOpenUpgrade then
                            self.itemArr[v.part]:onUpgardeClick();
                        end
                    else
                        if v.part == DataCenter.armySoulData.orderPart then
                            self.itemArr[v.part]:onUpgardeClick();
                        end
                    end
                end
            end
        end
    end
    
    self:createSkillItem();
end

function Lua_ArmyUpgradeWindow:onSelectEquipItem(data)-- 点击魂装
    self._data = data;
    self.army_icon:setAltas("armySoul", tostring("army_"..data.armyInfo.index));
    self.base_prop.text = data.armyOrderProp;
    if data.is_max_order == true then
        self.sprObg:SetActive(false);
        self.subBtn:setBtnEnable(false);
        self.sub_lab.text = LanUtil.getValue(140539);
        self.sub_lab:setLocation(220,-283,0);
        self.base_prop:setLocation(-205,-135,0);
    else
        self.base_prop:setLocation(-298,-135,0);
        self.sub_lab.text = LanUtil.getValue(140540);
        self.sub_lab:setLocation(102,-283,0);
        local tvo = Lua_ToolVo.createToolVo(data.equip_id);
        tvo.packType = 999;
    	self.image.data = tvo;
        self.image:showNumLimit(data.bag_order_num, data.need_order_num,2);

        self.sprObg:SetActive(true);
        self.subBtn:setBtnEnable(true);
        self.next_prop.text = data.armyNextOrderProp;
    end

    if data.isShowOrderRed == true then
        self.red:setEnable(true);
    else
        self.red:setEnable(false);
    end

    for k,v in pairs(self.data.armyEquipInfo) do
        if v.id ~= 0 then
            if v.part == data.part then
                self.itemArr[k].select:setEnable(true);
            else
                self.itemArr[k].select:setEnable(false);
            end
        end
    end
end

function Lua_ArmyUpgradeWindow:showWin(param)
	self:superCall("showWin", param);
    self.army_id = self.showData;
    self:updateArmyUpgradePanel();
end 

function Lua_ArmyUpgradeWindow:createSkillItem()
    local arr = self.data.armySkillInfo;
    if self.skillArr == nil then
        self.skillArr = Array();
        local poses = {{360,-133}};
        for i=1, arr:getSize() do
            if arr[i].skill_class == 3 then
                local item = Lua_ArmySkillItem.new(self.content);--左槽
                item:setLocation(poses[1][1], poses[1][2], 0);
                item:setCanClick(true);
                item:setSkillInfo(arr[i]);
                self.skillArr:add(item);
            end
        end
    else
        for i=1, arr:getSize() do
            if arr[i].skill_class == 3 then
                self.skillArr[1]:setSkillInfo(arr[i]);
            end
        end
    end
end

function Lua_ArmyUpgradeWindow:onUpgradeBtnClick()-- 升阶
    Lua_ProxyManager.getProxy("Lua_ArmySoulProxy"):sUpgardOrderEquip(self.army_id,self._data.part);
end

function Lua_ArmyUpgradeWindow:dispose()
    if self.itemArr ~= nil then
        for i=1,self.itemArr:getSize() do
            self.itemArr[i]:dispose();
        end
    end
    DataCenter.armySoulData.orderPart = nil;
    self:superCall("dispose");
end
