-- 魂印item

Lua_ArmyEquipItem = class("Lua_ArmyEquipItem", Lua_DisplayObject);
function Lua_ArmyEquipItem:ctor(p)
    self:superCall("ctor", p, "ArmyEquipItem_skin");
end

function Lua_ArmyEquipItem:buildShowItem()
    self:superCall("buildShowItem");
    self.addBtn.clickScale = false;
    self.addBtn:addClickFuntion(self, self.onAddClick);
end

function Lua_ArmyEquipItem:setEquipNnmetype(val)
    self.armyType = val;
	self.content.name = "Lua_ArmyEquipItem"..tostring(val);
end

function Lua_ArmyEquipItem:setEquipInfo(data)
    self.data = data;
    self.info = data.armyInfo;
    self.vo = data.armyEquipVo;
    self.up_order.uiwidget.gameObject:SetActive(false);

    if data.equip_id ~= nil and data.equip_id ~= 0 then
        self.addBtn:setEnable(false);
        self.army_icon:setEnable(true);
        self.army_lvl.uiwidget.gameObject:SetActive(true);

        if data.isCanUngarde ~= nil then
            self.army_order.text = data.army_order;
            self.army_order.uiwidget.gameObject:SetActive(true);
        else
            self.army_order.uiwidget.gameObject:SetActive(false);
        end
        self.army_lvl.text = data.army_lvl;
        self.army_icon:setAltas(tostring(self.data.armyEquipVo.atlas), tostring(self.data.armyEquipVo.referenceId));
    else
        self.addBtn:setEnable(true);
        self.army_icon:setEnable(false);
        self.army_lvl.uiwidget.gameObject:SetActive(false);
        self.army_order.uiwidget.gameObject:SetActive(false);
    end

    if data.isShowAdornRed == true or data.isShowIntensifyRed == true or data.isShowReplaceRed == true  then
        self:showRedDot(true);--红点
    else
        self:showRedDot(false);--红点
    end
    self:showArmyEff(true);
end

function Lua_ArmyEquipItem:setEquiplOrderInfo(data)
    self.data = data;
    self.info = data.armyInfo;
    self.vo = data.armyEquipVo;

    self.addBtn:setEnable(false);
    self.army_lvl.uiwidget.gameObject:SetActive(false);
    self.army_order.uiwidget.gameObject:SetActive(false);
    if data.equip_id ~= nil and data.equip_id ~= 0 then
        self.army_icon:setEnable(true);
        self.army_icon:setAltas(tostring(self.data.armyEquipVo.atlas), tostring(self.data.armyEquipVo.referenceId));
        if data.isCanUngarde ~= nil then
            self.up_order.text = data.army_order;
            self.up_order.uiwidget.gameObject:SetActive(true);
        else
            self.up_order.uiwidget.gameObject:SetActive(false);
        end
    else
        self.army_icon:setEnable(false);
        self.up_order.uiwidget.gameObject:SetActive(false);
    end

    if data.isShowOrderRed == true then
        self:showRedDot(true);--红点
    else
        self:showRedDot(false);--红点
    end

    self:showArmyEff(true);
end

function Lua_ArmyEquipItem:setCanClick(val)-- 背景添加点击方法
    if val == true then
        self.army_icon.mouseEnable = true;
        self.army_icon.clickScale = false;
        self.army_icon:addClickFuntion(self, self.onIconClick);
    else
        self.army_icon.mouseEnable = false;
        self.army_icon:removeClickFuntion(self, self.onIconClick);
    end
end

function Lua_ArmyEquipItem:setUngardeClick(val)-- 升阶添加点击方法
    if val == true then
        self.army_icon.mouseEnable = true;
        self.army_icon.clickScale = false;
        self.army_icon:addClickFuntion(self, self.onUpgardeClick);
    else
        self.army_icon.mouseEnable = false;
        self.army_icon:removeClickFuntion(self, self.onUpgardeClick);
    end
end

function Lua_ArmyEquipItem:setDepth(val)--层级
    self:superCall("setDepth", val);
    if (self.addBtn ~= nil) then self.addBtn:setDepth(val+ 5) end;
    if (self.select ~= nil) then self.select:setDepth(val + 5) end;
    if (self.army_icon ~= nil) then self.army_icon:setDepth(val + 2) end;
    if (self.army_lvl ~= nil) then self.army_lvl:setDepth(val + 6) end;
end

function Lua_ArmyEquipItem:showRedDot(val)--红点显示
    if val == true then
        if self._redDotIcon == nil then
            self._redDotIcon = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot",25,23, 0, 0);
            self._redDotIcon:setDepth(25);
            self._redDotIcon.name = "redDotIcon1";
        end
        self._redDotIcon:setEnable(true);
    else
        if self._redDotIcon ~= nil then
            self._redDotIcon:setEnable(false);
        end
    end
end

function Lua_ArmyEquipItem:showArmyEff(bShowEff)
    bShowEff = bShowEff == nil and false or bShowEff;
    if self.vo ~= nil and bShowEff == true then
        local str = self.vo.army_effect;
        if str == nil then
            if self.armyEff ~= nil then
                self.armyEff:dispose();
                self.armyEff = nil;
            end
            return;
        end
        if self.armyEff == nil then
            self.armyEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. str, str, 0, 0);
            self.armyEff:setLoop(true);
            self.armyEff:SetRenderQueue(self.army_icon, -5, 2, false);
        else
            self.armyEff:setUrl("/effects/scsEffects/" .. str, str);
        end
    else
        if self.armyEff ~= nil then
            self.armyEff:dispose();
            self.armyEff = nil;
        end
    end
end

function Lua_ArmyEquipItem:onAddClick()
    if self.info.activate == 1 then
        DataCenter.armySoulData.isSelectPack = false;
        Lua_WindowUtil.openWin("Lua_ArmyEquipPackWindow",WinParam.ACTION_OPEN,{soulType = self.info.soul_type})
    else
        OperateAlert.show(LanUtil.getValue(140519));
    end
end

function Lua_ArmyEquipItem:onIconClick()
    Lua_MsgUtil.callFunc("SHOW_SELECT_ITEM",self.data.part);
    Lua_PackUtil.showItemInfo(self.data.armyEquipVo,false,nil,true);--显示Tips
end

function Lua_ArmyEquipItem:onUpgardeClick()
    if self.data.isCanUngarde ~= nil then
        DataCenter.armySoulData.orderPart = self.data.part;
        Lua_MsgUtil.callFunc("SHOW_ORDER_ITEM",self.data);
    else
        OperateAlert.show(LanUtil.getValue(140541));
        return;
    end
end


function Lua_ArmyEquipItem:dispose()
    self:superCall("dispose");
end