--披风附灵

Lua_CloakAddWindow = class("Lua_CloakAddWindow", Lua_SecondSizeWindow)
function Lua_CloakAddWindow:ctor()
    self:superCall("ctor");
    self.resolveArr = Array();
    self.windowName = "Lua_CloakAddWindow";
    self.skinName = "cloakAttachWindow_skin";
    self.titleText = LanUtil.getValue(140002);
end

function Lua_CloakAddWindow:dispose()
	self:superCall("dispose");
end

function Lua_CloakAddWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.starArr = Array();

	self.fightNum = Lua_NumberImage.new(self.content);
    self.fightNum.prefix = "gold_";
    self.fightNum.num = 0;
    self.fightNum:setDepth(6);
    self.fightNum:setLocation(-200, -197, 0);

	self.help:addClickFuntion(self,self.onHelp);--问号
	self.intensifyBtn:addClickFuntion(self, self.onAdjoinBtnClick); -- 附灵

	self:addLuaEvent("PACK_CLOAK_UPDATE", self, self.updatePanelInfo);
	self:addLuaEvent("UPDATE_CLOAK_INFO", self, self.updatePanelInfo);
	self:updatePanelInfo()
end

function Lua_CloakAddWindow:updatePanelInfo()
	local id = DataCenter.cloakData.selectCloakId;
	self.data = DataCenter.cloakData:getArrByCloakInfo(id);

	self.fightNum.num = self.data.cloakAdjoinForce;
	self.fightNum:setNumScale(1.3,1.3);
	self.nameTxt.text = self.data.cloakName
	self.levelTxt.text = self.data.cloak_lvl
	self.base_prop.text = self.data.cloakAdjoinName;
	self.num_prop.text = self.data.cloakAdjoinProp;
	self.des.text = LanUtil.getValue(140009);

	if self.data.isShowAdjoinRed == true then
		self.intensifyRed:setEnable(true);
	else
		self.intensifyRed:setEnable(false);
	end

	if self.data.isMaxStar == true and self.data.isShowAdjoinTips == true then
		self.showObg:SetActive(false);
	else
		self.showObg:SetActive(true);
	end

	self:createItem();
	self:showCloakModel();
end

function Lua_CloakAddWindow:createItem()
	local arr = self.data.adjoin_cost;
	if self.itemArr == nil then
		self.itemArr = Array();
		local len = arr:getSize();
		for i=1,len do
			local item = Lua_ToolImage.new(self.showObg);
			item:setDepth(10);
			item:setLocation(340-i*70,-280,0)
			item.data = arr[i];
			item:showNumLimit(arr[i].bagNum,arr[i].needNum,2)
			item:setScale(0.8,0.8);
			self.itemArr:add(item)
		end
	else
		for i=1,self.itemArr:getSize() do
			self.itemArr[i]:showNumLimit(arr[i].bagNum,arr[i].needNum,2)
		end
	end
end

function Lua_CloakAddWindow:showCloakModel()
    local shapeConfig = self.data.shapeConfig;

    if shapeConfig == nil then 
        return print("not_Model");
    end
    self.floder = shapeConfig.floder;
    self.fileName = shapeConfig.fileName;
    self.modelName = shapeConfig.modelName;


    if self._modelEffect ~= nil then
        self._modelEffect:dispose()
    end

    local modelpos = self.data.modelpos;
    local modelros = self.data.modelros;
    local modelsca = self.data.modelsca;

    self._modelEffect = UIModelTexture();
    
    local imgPos = Vector2(-150, 10);
    local imgSize = Vector2(1175, 680);
    local modelRot = Vector3(0, 180, 0);
    local modelOffset = Vector2(-265, -250);

    self._modelEffect:init(self.content,imgPos,imgSize,3,modelRot,modelOffset,160);               
    self._modelEffect:setRotEnable(true,0, 0, 300, 400, 2)
    self._modelEffect:setCamPos(20000,0,0);
    self._modelEffect:setModelOffset(modelpos[1]-130,modelpos[2],modelpos[3]);

    self._modelEffect:setModelAngle(modelros[1],modelros[2],modelros[3]);
    self._modelEffect:setCamView(15);
    self._modelEffect.uiEffect:setSacle(modelsca[1],modelsca[2],modelsca[3])
    self._modelEffect:setUrl(self.floder.."/"..self.fileName,self.modelName)
end

function Lua_CloakAddWindow:onAdjoinBtnClick() --   附灵
	if self.data.isHaveAdjoinItem == true then --附灵材料满足
		if self.data.isShowAdjoinTips == true then
			local tipData = {};
		    tipData.des = LanUtil.getValue(140012);
		    tipData.owner = self;
		    tipData.type = 1;
		    tipData.subFun = self.onSubOpenback;
		    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		else
			Lua_ProxyManager.getProxy("Lua_CloakProxy"):sSttachQuick(self.data.cloak_id);
		end
	else
		local tipData = {};
	    tipData.des = LanUtil.getValue(140011);
	    tipData.owner = self;
	    tipData.type = 1;
	    tipData.subFun = self.onSubCallback;
	    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_CloakAddWindow:onSubCallback()
    Lua_WindowUtil.openWin("Lua_CloakAddWindow",WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_SacredWindow",WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_MultipleServersWindow", WinParam.ACTION_OPEN, {openIdx = 3});
end

function Lua_CloakAddWindow:onSubOpenback()
    Lua_WindowUtil.openWin("Lua_CloakAddWindow",WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_UpgradeStarWindow",WinParam.ACTION_OPEN);
end

function Lua_CloakAddWindow:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(140003));
end