--披风强化

Lua_CloakIntensifyWindow = class("Lua_CloakIntensifyWindow", Lua_SecondSizeWindow)
function Lua_CloakIntensifyWindow:ctor()
    self:superCall("ctor");
    self.resolveArr = Array();
    self.windowName = "Lua_CloakIntensifyWindow";
    self.skinName = "cloakIntensifyWindow_skin";
    self.titleText = LanUtil.getValue(140008);
end

function Lua_CloakIntensifyWindow:dispose()
	self:superCall("dispose");
end

function Lua_CloakIntensifyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.intensifyBtn:addClickFuntion(self, self.onIntensifyBtnClick); -- 强化

	self:addLuaEvent("UPDATE_CLOAK_INFO", self, self.updatePanelInfo);
	self:updatePanelInfo()
end

function Lua_CloakIntensifyWindow:updatePanelInfo()
	local id = DataCenter.cloakData.selectCloakId;
	self.data = DataCenter.cloakData:getArrByCloakInfo(id);

	self.nameTxt.text = self.data.cloakName;
	self.levelTxt.text = self.data.cloak_lvl;
	self.base_prop.text = self.data.cloakIntensifyProp;
	
	if self.data.isShowIntensifyRed == true then
		self.intensifyRed:setEnable(true);
	else
		self.intensifyRed:setEnable(false);
	end

	if self.data.isMaxIntensifyLvl == true then
		self.showObg:SetActive(false);
		self.base_prop:setLocation(250,120,0);
	else
		self:createItem();
		self.showObg:SetActive(true);
		self.base_prop:setLocation(172,120,0);
		self.add_prop.text = self.data.cloakNextIntensifyProp;
	end

	self:showCloakModel();
end

function Lua_CloakIntensifyWindow:createItem()
	local arr = self.data.intensify_cost;
	if self.itemArr == nil then
		self.itemArr = Array();
		local len = arr:getSize();
		for i=1,len do
			local item = Lua_ToolImage.new(self.showObg);
			item:setDepth(10);
			item:setLocation(340-i*70,-280,0)
			item.data = arr[i];
			item:showNumLimit(arr[i].bagNum,arr[i].needNum,2)
			item:setScale(0.8,0.8);
			self.itemArr:add(item)
		end
	else
		for i=1,self.itemArr:getSize() do
			self.itemArr[i]:showNumLimit(arr[i].bagNum,arr[i].needNum,2)
		end
	end
end

function Lua_CloakIntensifyWindow:showCloakModel()
    local shapeConfig = self.data.shapeConfig;

    if shapeConfig == nil then 
        return print("not_Model");
    end
    self.floder = shapeConfig.floder;
    self.fileName = shapeConfig.fileName;
    self.modelName = shapeConfig.modelName;


    if self._modelEffect ~= nil then
        self._modelEffect:dispose()
    end

    local modelpos = self.data.modelpos;
    local modelros = self.data.modelros;
    local modelsca = self.data.modelsca;

    self._modelEffect = UIModelTexture();
    
    local imgPos = Vector2(-150, 10);
    local imgSize = Vector2(1175, 680);
    local modelRot = Vector3(0, 180, 0);
    local modelOffset = Vector2(-265, -250);

    self._modelEffect:init(self.content,imgPos,imgSize,3,modelRot,modelOffset,160);               
    self._modelEffect:setRotEnable(true,0, 0, 300, 400, 2)
    self._modelEffect:setCamPos(20000,0,0);
    self._modelEffect:setModelOffset(modelpos[1]-130,modelpos[2],modelpos[3]);

    self._modelEffect:setModelAngle(modelros[1],modelros[2],modelros[3]);
    self._modelEffect:setCamView(15);
    self._modelEffect.uiEffect:setSacle(modelsca[1],modelsca[2],modelsca[3])
    self._modelEffect:setUrl(self.floder.."/"..self.fileName,self.modelName)
end

function Lua_CloakIntensifyWindow:onIntensifyBtnClick() -- 强化	
	if self.data.isHaveIntensifyItem == true then   -- 强化材料满足
		if self.data.isMaxIntensifyLvl == false and self.data.isBreakIntensify == true then
			local tipData = {};
		    tipData.des = LanUtil.getValue(140013);
		    tipData.owner = self;
		    tipData.type = 1;
		    tipData.subFun = self.onSubOpenback;
		    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		else
			Lua_ProxyManager.getProxy("Lua_CloakProxy"):sIntensifyCloak(self.data.cloak_id);
		end
	else
		local tipData = {};
	    tipData.des = LanUtil.getValue(140011);
	    tipData.owner = self;
	    tipData.type = 1;
	    tipData.subFun = self.onSubCallback;
	    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_CloakIntensifyWindow:onSubCallback()
    Lua_WindowUtil.openWin("Lua_CloakIntensifyWindow",WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_SacredWindow",WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_MultipleServersWindow", WinParam.ACTION_OPEN, {openIdx = 3});
end

function Lua_CloakIntensifyWindow:onSubOpenback()
    Lua_WindowUtil.openWin("Lua_CloakIntensifyWindow",WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_UpgradeStarWindow",WinParam.ACTION_OPEN);
end