--披风分解

Lua_CloakResolveWindow = class("Lua_CloakResolveWindow", Lua_SecondSizeWindow)
function Lua_CloakResolveWindow:ctor()
    self:superCall("ctor");
    self.resolveArr = Array();
    self.windowName = "Lua_CloakResolveWindow";
    self.skinName = "cloakResolveWindow_skin";
    self.titleText = LanUtil.getValue(140004);
end

function Lua_CloakResolveWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 962, 424));
    self.recordsList:setLocation(6, 21, 0);
    self.recordsList:setListCell(Lua_StampResolveItem, 90, 97, 10);
    
    self.num_sprit1:setAltas("item15", "207110404");
    self.num_sprit1.clickScale = false;
    self.num_sprit1:addClickFuntion(self, self.onOpenOenTips);

    self.num_sprit2:setAltas("item15", "207110403");
    self.num_sprit2.clickScale = false;
    self.num_sprit2:addClickFuntion(self, self.onOpenTwoTips);

    self.num_sprit3:setAltas("item15", "207110402");
    self.num_sprit3.clickScale = false;
    self.num_sprit3:addClickFuntion(self, self.onOpenThreeTips);

    self.num_sprit4:setAltas("item15", "207110401");
    self.num_sprit4.clickScale = false;
    self.num_sprit4:addClickFuntion(self, self.onOpenFourTips);

    self.help:addClickFuntion(self, self.onHelpClick);
    self.resolveBtn:addClickFuntion(self, self.onResolveClick);
 
    self:onUpdatePackInfo();
    self:addLuaEvent("UPDATE_CLOAK_SELCET", self, self.onSelectCloakInfo);
    self:addLuaEvent("UPDATE_CLOAK_INFO", self, self.onUpdatePackInfo);
    self:addLuaEvent("PACK_CLOAK_UPDATE", self, self.onUpdatePackInfo); -- 背包获取新道具 更新分解数据
end

function Lua_CloakResolveWindow:onUpdatePackInfo()--背包数据
    local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK); --背包
    local arr = bagData:getBagAllData();
    
    self.resolveList = Array()
    local len = DataCenter.cloakData.pack_size;
    for i=1,len do
        if arr[i] ~= nil then
            if arr[i].subType == Lua_PackTypeDefine.CLOAK_ITEM or arr[i].subType == Lua_PackTypeDefine.CLOAK_RESOLVE_ITEM 
            or arr[i].subType == Lua_PackTypeDefine.CLOAK_ITEM_CHIP then
                local weight = 0;
                local isSelect = false;
                if arr[i].subType == Lua_PackTypeDefine.CLOAK_ITEM then
                    weight = 10000+arr[i].color;
                elseif arr[i].subType == Lua_PackTypeDefine.CLOAK_ITEM_CHIP then
                    weight = arr[i].color;
                elseif arr[i].subType == Lua_PackTypeDefine.CLOAK_RESOLVE_ITEM then
                    weight = 50000+arr[i].color;
                    isSelect = true
                end
                self.resolveList:add({vo = arr[i], isSelect = isSelect, weight = weight});
            end
        else
            self.resolveList:add({vo = nil, isSelect = false, weight=0});
        end
    end
    self.resolveList:sort("weight", true);
    self.recordsList:setLuaArrayData(self.resolveList, false);

    self:onResolveCloakData()--分解数据
end

function Lua_CloakResolveWindow:onResolveCloakData()--分解数据
    self.resolveArr:clear();
    local len = self.resolveList:getSize();
    for i=1,len do
        if self.resolveList[i].isSelect == true then
            local list  = {};
            list.index = self.resolveList[i].vo.index;
            list.id = self.resolveList[i].vo.id;
            list.count = self.resolveList[i].vo.count;
            list.color = self.resolveList[i].vo.color;
            list.decompose = DataCenter.cloakData:decompose(self.resolveList[i].vo.id);
            list.subType = self.resolveList[i].vo.subType;
            self.resolveArr:add(list);      
        end
    end
    local color = "[192e41]";
    local color1 = "[13a100]";
    if self.resolveArr:getSize() > 0  then
        self.numTxt1.text = color.. DataCenter.cloakData.cloak_pink.."[-]"..color1.."+"..DataCenter.cloakData:cloakResolveNum(self.resolveArr,Lua_ToolVo.new(207110404).color);
        self.numTxt2.text = color.. DataCenter.cloakData.cloak_red.."[-]"..color1.."+"..DataCenter.cloakData:cloakResolveNum(self.resolveArr,Lua_ToolVo.new(207110403).color);
        self.numTxt3.text = color.. DataCenter.cloakData.cloak_orange.."[-]"..color1.."+"..DataCenter.cloakData:cloakResolveNum(self.resolveArr,Lua_ToolVo.new(207110402).color);
        self.numTxt4.text = color.. DataCenter.cloakData.cloak_purple.."[-]"..color1.."+"..DataCenter.cloakData:cloakResolveNum(self.resolveArr,Lua_ToolVo.new(207110401).color);
    else
        self.numTxt1.text = color.. DataCenter.cloakData.cloak_pink;
        self.numTxt2.text = color.. DataCenter.cloakData.cloak_red;
        self.numTxt3.text = color.. DataCenter.cloakData.cloak_orange;
        self.numTxt4.text = color.. DataCenter.cloakData.cloak_purple;
    end

    self:updateCardResolveRed()--红点显示
    --背包数据
end

function Lua_CloakResolveWindow:onSelectCloakInfo()--点击 单个灵纹 刷新界面
    self:onResolveCloakData();
    self:updateSelect();
end

function Lua_CloakResolveWindow:onResolveTipsClick()
    local tipData = {};
    tipData.des = LanUtil.getValue(140015)
    tipData.owner = self;
    tipData.type = 1;
    tipData.subFun = self.onSubCallback;
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_CloakResolveWindow:onResolveClick()
    local isResolve = false;
    local len = self.resolveArr:getSize()
    if len > 0 then
        for i=1,len do
            if self.resolveArr[i].subType == Lua_PackTypeDefine.CLOAK_ITEM 
                or self.resolveArr[i].subType == Lua_PackTypeDefine.CLOAK_ITEM_CHIP then
                isResolve = true;
            end
        end
        if isResolve == true then
            self:onResolveTipsClick();
        else
            self:onSubCallback();
        end
    else
        OperateAlert.show(LanUtil.getValue(140014));
    end
end

function Lua_CloakResolveWindow:onSubCallback()
    Lua_ProxyManager.getProxy("Lua_CloakProxy"):sResolveCloak(self.resolveArr);
    if self.resolveList ~= nil then
        self.resolveList:clear();
    end

    if self.resolveArr ~= nil then
        self.resolveArr:clear();
    end
end

function Lua_CloakResolveWindow:updateSelect()
    if self.recordsList ~= nil then
        local arr = self.recordsList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateSelect();
        end
    end
end

function Lua_CloakResolveWindow:updateCardResolveRed() --红点更新
    local isShowResolveRed = DataCenter.cloakData:isShowCloakResolveRed();
    if isShowResolveRed == true then
        self:showRedDot(true);--分解红点显示
    else
        self:showRedDot(false);
    end
end

function Lua_CloakResolveWindow:showRedDot(val)--红点显示
    if val == true then
        if self._redDotIcon == nil then
            self._redDotIcon = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot",501,-255, 0, 0);
            self._redDotIcon:setDepth(7);
            self._redDotIcon.name = "redDotIcon1";
        end
        self._redDotIcon:setEnable(true);
    else
        if self._redDotIcon ~= nil then
            self._redDotIcon:setEnable(false);
        end
    end
end

function Lua_CloakResolveWindow:onOpenStampStoneTips()--魂石Tips
    Lua_PackUtil.showItemInfo(Lua_ToolVo.new(201050021),false)
end

function Lua_CloakResolveWindow:onHelpClick()
    --print("描述")
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(140005));
end

function Lua_CloakResolveWindow:onOpenOenTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(207110404),false)
end

function Lua_CloakResolveWindow:onOpenTwoTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(207110403),false)
end

function Lua_CloakResolveWindow:onOpenThreeTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(207110402),false)
end

function Lua_CloakResolveWindow:onOpenFourTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(207110401),false)
end

function Lua_CloakResolveWindow:dispose()
    if self.recordsList ~= nil then
        self.recordsList:dispose()
        self.recordsList = nil;
    end
    if self.resolveList ~= nil then
        self.resolveList:clear();
        self.resolveList = nil; 
    end
    if self.resolveArr ~= nil then
        self.resolveArr:clear();
        self.resolveArr = nil; 
    end
    self:superCall("dispose");
end

















Lua_StampResolveItem = class("Lua_StampResolveItem", Lua_ListCell);
function Lua_StampResolveItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_StampResolveItem:buildShowItem()
    self:superCall("buildShowItem");
    if self.itemImage == nil then
        self.itemImage = Lua_ToolImage.new(self.content);
        self.itemImage:setDepth(3);
        self.itemImage:setLocation(0,6,0);
        self.itemImage:setCanClick(false);
    end
end

 function Lua_StampResolveItem:setData(data)
    self.data = data;
    self.vo = data.vo;
    self.itemImage.data = self.vo;
    --self.itemImage:showBetterTip(0);
    if self.vo ~= nil then
        if self.vo.stamp_type ~=0 then
            self.itemImage:showStampEff(true);
        else
            self.itemImage:showStampEff(false);
        end
        
    end
    self:updateSelect();
 end

function Lua_StampResolveItem:updateSelect()
    if self.data.isSelect == true then
        if self.shade == nil then
            self.shade = UICreate.createUIAtlasImage(self.content, "iconantlas1", "tick_green", 0, 6, 0, 0);
            self.shade:setDepth(10);
        end
        self.shade:setEnable(true);
        self.itemImage:setGray(true);
    else
        if self.shade ~= nil then
            self.shade:setEnable(false);
        end
        
        self.itemImage:setGray(false);
    end
end

function Lua_StampResolveItem:checkOutBound(showRect)
    if self.data == nil or self.vo == nil then
        self.inViewEffect = false;
        return;
    end
    local rect = Lua_Rectangle.new(self.itemX - 40, self.itemY - 24, 70,60);
    if showRect:containeRect(rect) == true then
        if self.vo.stamp_type == 0 then
            self.inViewEffect = false;
        else
            if self.vo.color >= 2 then
                self.inViewEffect = true;
            else
                self.inViewEffect = false;
            end
        end
    else
        self.inViewEffect = false;
    end
    self:updateEffectState();
end

function Lua_StampResolveItem:updateEffectState()
    if self.inViewEffect == true then
        if self.itemImage.stampEff == nil then
            self.itemImage:showStampEff(true);
        end
    else
        self.itemImage:showStampEff(false);
    end
end
function Lua_StampResolveItem:onPlayerSoundClick(go)
    if self.vo ~= nil then
        if self.data.isSelect == true then
            self.data.isSelect = false;
        else
            self.data.isSelect = true;
        end
        Lua_MsgUtil.callFunc("UPDATE_CLOAK_SELCET");
    end
end

function Lua_StampResolveItem:dispose()
    self:superCall("dispose");
end