--披风Panel

Lua_CloakSubPanel  = class("Lua_CloakSubPanel",Lua_DisplayObject);
function Lua_CloakSubPanel:ctor(p)	
	self:superCall("ctor", p,"cloakWindow_skin");
end

function Lua_CloakSubPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.starArr = Array();
	local len = DataCenter.cloakData.cloak_star;
	for i=1,len do
		local star = UICreate.createUIAtlasImage(self.content, "iconantlas1", "star_0", 0, 0, 0, 0);
		star:setDepth(10);
		star:setLocation(-292+i*50,-220,0);
		self.starArr:add(star);
	end

	self.num_sprit1:setAltas("item15", "207110404");
    self.num_sprit1.clickScale = false;
    self.num_sprit1:addClickFuntion(self, self.onOpenOenTips);

    self.num_sprit2:setAltas("item15", "207110403");
    self.num_sprit2.clickScale = false;
    self.num_sprit2:addClickFuntion(self, self.onOpenTwoTips);

    self.num_sprit3:setAltas("item15", "207110402");
    self.num_sprit3.clickScale = false;
    self.num_sprit3:addClickFuntion(self, self.onOpenThreeTips);

    self.num_sprit4:setAltas("item15", "207110401");
    self.num_sprit4.clickScale = false;
    self.num_sprit4:addClickFuntion(self, self.onOpenFourTips);

    self.starRed:setEnable(false);
    self.resolveRed:setEnable(false);
    self.addRed:setEnable(false);
    self.intensifyRed:setEnable(false);
    self.downObj:SetActive(false);
    

	self.shapeBtn:addClickFuntion(self, self.onShapeBtnClick);         -- 化形
	self.starBtn:addClickFuntion(self, self.onStarBtnClick);           -- 升星
	self.resolveBtn:addClickFuntion(self, self.onResolveBtnClick);     -- 分解
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);             -- 附灵
	self.intensifyBtn:addClickFuntion(self, self.onIntensifyBtnClick); -- 强化
	self.activateBtn:addClickFuntion(self, self.onActivateBtnClick);   -- 激活 
	self.selectCheckBox:addBoxChange(self, self.onSelectBoxClick);     -- 隐藏
end

function Lua_CloakSubPanel:setData(data)
	self.data = data;
	self.nameTxt.text = self.data.cloakName;
	self.levelTxt.text = self.data.cloak_lvl;
	self.base_prop.text = self.data.cloakBaseProp;
	self.add_prop.text = self.data.cloakAdjoinName;
	self.num_prop.text = self.data.cloakAdjoinProp;

	self.numTxt1.text = DataCenter.cloakData.cloak_pink;
    self.numTxt2.text = DataCenter.cloakData.cloak_red;
    self.numTxt3.text = DataCenter.cloakData.cloak_orange;
    self.numTxt4.text = DataCenter.cloakData.cloak_purple;
	if self.data.activate == 0 then
		self.downObj:SetActive(true);
		if self.data.isShowActivatRed == true then
			self.activateBtn:setBtnEnable(true)
		else
			self.activateBtn:setBtnEnable(false)
		end

		self.makObg:SetActive(false);
		self.starBtn:setEnable(false);
		self.shapeBtn:setEnable(false);
		self.starRed:setEnable(false);
		self.selectCheckBox:setEnable(false);
		self.resolveBtn.mainContent:SetActive(false);
		self.addBtn.mainContent:SetActive(false);
		self.intensifyBtn.mainContent:SetActive(false);
		self.lock:setLocation(self.data.pos[1],self.data.pos[2],self.data.pos[3]);
		self.lock:setScale(self.data.sacle[1],self.data.sacle[2],self.data.sacle[3]);
		self:createItem();
	else
		if self.data.isSwitch == 0 then
			self.makObg:SetActive(false);
			self.shapeBtn:setEnable(true);
	    else
	    	self.makObg:SetActive(true);
	    	self.shapeBtn:setEnable(false);
	    end
	    if DataCenter.cloakData.hide_state == 1 then
	    	self.selectCheckBox.seleted = false;
	    else
	    	self.selectCheckBox.seleted = true;
	    end
		self.starBtn:setEnable(true);
		self.downObj:SetActive(false);
		self.selectCheckBox:setEnable(true);
		self.resolveBtn.mainContent:SetActive(true);
		self.addBtn.mainContent:SetActive(true);
		self.intensifyBtn.mainContent:SetActive(true);
	end

	local len = self.starArr:getSize();
	for i=1,len do
		if self.data.activate ~= 0 then
			self.starArr[i]:setEnable(true);
			if i <= self.data.star then
				self.starArr[i]:setGray(false);
			else
				self.starArr[i]:setGray(true);
			end
		else
			self.starArr[i]:setEnable(false);
		end
	end

	self:showCloakModel();
	self:updateIsShowRed();-- 红点
end

function Lua_CloakSubPanel:createItem()
	if self.itemArr ~=nil then
		for i=1,self.itemArr:getSize() do
			self.itemArr[i]:dispose();
		end
	end
	self.itemArr = Array();
	self.itemArr:clear();
	local arr = self.data.activation_cost;
	local len = arr:getSize();
	for i=1,len do
		local item = Lua_ToolImage.new(self.downObj);
		item:setDepth(10);
		item:setLocation(370-i*70,-313,0)
		item.data = arr[i];
		item:showNumLimit(arr[i].bagNum,arr[i].needNum,2)
		item:setScale(0.8,0.8);
		self.itemArr:add(item);
	end
	self.dis:setLocation(258-len*70,-312,0)
end

function Lua_CloakSubPanel:showCloakModel()
    local shapeConfig = self.data.shapeConfig;
    if shapeConfig == nil then 
        return print("not_Model");
    end
    self.floder = shapeConfig.floder;
    self.fileName = shapeConfig.fileName;
    self.modelName = shapeConfig.modelName;

    if self._modelEffect ~= nil then
        self._modelEffect:dispose()
    end

    local modelpos = self.data.modelpos;
    local modelros = self.data.modelros;
    local modelsca =self.data.modelsca;

    self._modelEffect = UIModelTexture();
    
    local imgPos = Vector2(-150, 10);
    local imgSize = Vector2(1175, 680);
    local modelRot = Vector3(0, 180, 0);
    local modelOffset = Vector2(-265, -250);

    self._modelEffect:init(self.content,imgPos,imgSize,3,modelRot,modelOffset,160);
    self._modelEffect:setCamPos(10000,0,0);
    self._modelEffect:setModelOffset(modelpos[1],modelpos[2],modelpos[3]);
    if self.data.activate == 0 then
    	self._modelEffect.uiEffect:setGray(true);
    	self._modelEffect:setRotEnable(false,0, 0, 300, 400, 2)
    else
	    self._modelEffect.uiEffect:setGray(false);
	    self._modelEffect:setRotEnable(true,0, 0, 300, 400, 2)
	end

    self._modelEffect:setModelAngle(modelros[1],modelros[2],modelros[3]);
    self._modelEffect:setCamView(15);
    self._modelEffect.uiEffect:setSacle(modelsca[1],modelsca[2],modelsca[3])
    self._modelEffect:setUrl(self.floder.."/"..self.fileName,self.modelName)
end

function Lua_CloakSubPanel:updateIsShowRed()
	if self.data.activate == 1 then
		self.activateRed:setEnable(false);
		if self.data.isShowUpgradeStarRed == true then
			self.starRed:setEnable(true);
		else
			self.starRed:setEnable(false);
		end

		if self.data.isShowIntensifyRed == true then
			self.intensifyRed:setEnable(true);
		else
			self.intensifyRed:setEnable(false);
		end

		if DataCenter.cloakData:isShowCloakResolveRed() == true then
			self.resolveRed:setEnable(true);
		else
			self.resolveRed:setEnable(false);
		end

		if self.data.isShowAdjoinRed == true then
			self.addRed:setEnable(true);
		else
			self.addRed:setEnable(false);
		end 
	else
		self.addRed:setEnable(false);
		self.resolveRed:setEnable(false);
		self.intensifyRed:setEnable(false);
		if self.data.isShowActivatRed == true then
			self.activateRed:setEnable(true);
		else
			self.activateRed:setEnable(false);
		end
	end
end

function Lua_CloakSubPanel:onOpenOenTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(207110404),false)
end

function Lua_CloakSubPanel:onOpenTwoTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(207110403),false)
end

function Lua_CloakSubPanel:onOpenThreeTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(207110402),false)
end

function Lua_CloakSubPanel:onOpenFourTips()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(207110401),false)
end

function Lua_CloakSubPanel:onShapeBtnClick()     -- 化形
	Lua_ProxyManager.getProxy("Lua_CloakProxy"):sChangeCloak(self.data.cloak_id,1)
end

function Lua_CloakSubPanel:onStarBtnClick()      -- 升星
	Lua_WindowUtil.openWin("Lua_UpgradeStarWindow",WinParam.ACTION_OPEN);
end

function Lua_CloakSubPanel:onResolveBtnClick()   -- 分解
	Lua_WindowUtil.openWin("Lua_CloakResolveWindow",WinParam.ACTION_OPEN);
end

function Lua_CloakSubPanel:onAddBtnClick()       -- 附灵
	Lua_WindowUtil.openWin("Lua_CloakAddWindow",WinParam.ACTION_OPEN);
end

function Lua_CloakSubPanel:onIntensifyBtnClick() -- 强化
	Lua_WindowUtil.openWin("Lua_CloakIntensifyWindow",WinParam.ACTION_OPEN);
end

function Lua_CloakSubPanel:onActivateBtnClick()  -- 激活 
	Lua_ProxyManager.getProxy("Lua_CloakProxy"):sActivateCloak(self.data.cloak_id);
end

function Lua_CloakSubPanel:onSelectBoxClick(state)    -- 隐藏
	if state == true then
        Lua_ProxyManager.getProxy("Lua_CloakProxy"):sCloakState(0);
    else
		Lua_ProxyManager.getProxy("Lua_CloakProxy"):sCloakState(1);
    end
	
end

function Lua_CloakSubPanel:dispose()	
	self:superCall("dispose");
	if self.starArr ~= nil then
		self.starArr:dispose();
		self.starArr = nil;
	end
end