--披风升星

Lua_UpgradeStarWindow = class("Lua_UpgradeStarWindow", Lua_SecondSizeWindow)
function Lua_UpgradeStarWindow:ctor()
    self:superCall("ctor");
    self.resolveArr = Array();
    self.windowName = "Lua_UpgradeStarWindow";
    self.skinName = "cloakStarWindow_skin";
    self.titleText = LanUtil.getValue(140006);
end

function Lua_UpgradeStarWindow:dispose()
	self:superCall("dispose");
	if self.starArr ~= nil then
		self.starArr:dispose();
		self.starArr = nil;
	end
end

function Lua_UpgradeStarWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.starArr = Array();
	local len = DataCenter.cloakData.cloak_star;
	for i=1,len do
		local star = UICreate.createUIAtlasImage(self.content, "iconantlas1", "star_0", 0, 0, 0, 0);
		star:setDepth(10);
		star:setLocation(-340+i*50,-200,0);
		self.starArr:add(star);
	end

	self.help:addClickFuntion(self,self.onHelp);--问号
	self.intensifyBtn:addClickFuntion(self, self.onUpgradeStarBtnClick); -- 升星

	self:addLuaEvent("PACK_CLOAK_UPDATE", self, self.updatePanelInfo);
	self:addLuaEvent("UPDATE_CLOAK_INFO", self, self.updatePanelInfo);
	self:updatePanelInfo()
end

function Lua_UpgradeStarWindow:updatePanelInfo()
	local id = DataCenter.cloakData.selectCloakId;
	self.data = DataCenter.cloakData:getArrByCloakInfo(id);
	self.nameTxt.text = self.data.cloakName
	self.levelTxt.text = self.data.cloak_lvl
	self.base_prop.text = self.data.cloakStarProp;

	local len = self.starArr:getSize();
	for i=1,len do
		if i <= self.data.star then
			self.starArr[i]:setGray(false);
		else
			self.starArr[i]:setGray(true);
		end
	end

	if self.data.isShowUpgradeStarRed == true then
		self.intensifyRed:setEnable(true);
	else
		self.intensifyRed:setEnable(false);
	end

	if self.data.isMaxStar == true then
		self.showObg:SetActive(false);
		self.sprObg:SetActive(false);
		self.base_prop:setLocation(250,120,0);
	else
		self:createItem();
		self.sprObg:SetActive(true);
		self.showObg:SetActive(true);
		self.base_prop:setLocation(172,120,0);
		self.add_prop.text = self.data.cloakNextStarProp;
	end
	self:showCloakModel();
end

function Lua_UpgradeStarWindow:createItem()
	local arr = self.data.upgrade_cost;
	if self.itemArr == nil then
		self.itemArr = Array();
		local len = arr:getSize();
		for i=1,len do
			local item = Lua_ToolImage.new(self.showObg);
			item:setDepth(10);
			item:setLocation(340-i*70,-280,0)
			item.data = arr[i];
			item:showNumLimit(arr[i].bagNum,arr[i].needNum,2)
			item:setScale(0.8,0.8);
			self.itemArr:add(item)
		end
	else
		for i=1,self.itemArr:getSize() do
			self.itemArr[i]:showNumLimit(arr[i].bagNum,arr[i].needNum,2)
		end
	end
end

function Lua_UpgradeStarWindow:showCloakModel()
    local shapeConfig = self.data.shapeConfig;
    
    if shapeConfig == nil then 
        return print("not_Model");
    end
    self.floder = shapeConfig.floder;
    self.fileName = shapeConfig.fileName;
    self.modelName = shapeConfig.modelName;

    if self._modelEffect ~= nil then
        self._modelEffect:dispose()
    end

    local modelpos = self.data.modelpos;
    local modelros = self.data.modelros;
    local modelsca = self.data.modelsca;

    self._modelEffect = UIModelTexture();
    
    local imgPos = Vector2(-150, 10);
    local imgSize = Vector2(1175, 680);
    local modelRot = Vector3(0, 180, 0);
    local modelOffset = Vector2(-265, -250);

    self._modelEffect:init(self.content,imgPos,imgSize,3,modelRot,modelOffset,160);               
    self._modelEffect:setRotEnable(true,0, 0, 300, 400, 2)
    self._modelEffect:setCamPos(20000,0,0);
    self._modelEffect:setModelOffset(modelpos[1] - 130,modelpos[2],modelpos[3]);
  
    self._modelEffect:setModelAngle(modelros[1],modelros[2],modelros[3]);
    self._modelEffect:setCamView(15);
    self._modelEffect.uiEffect:setSacle(modelsca[1],modelsca[2],modelsca[3])
    self._modelEffect:setUrl(self.floder.."/"..self.fileName,self.modelName)
end

function Lua_UpgradeStarWindow:onUpgradeStarBtnClick() -- 升星
	
	if self.data.isShowUpgradeStarRed == true then
		Lua_ProxyManager.getProxy("Lua_CloakProxy"):sUpgradeStar(self.data.cloak_id)
	else
		local tipData = {};
	    tipData.des = LanUtil.getValue(140011)
	    tipData.owner = self;
	    tipData.type = 1;
	    tipData.subFun = self.onSubCallback;
	    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_UpgradeStarWindow:onSubCallback()
    Lua_WindowUtil.openWin("Lua_UpgradeStarWindow",WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_SacredWindow",WinParam.ACTION_CLOSE);
    Lua_WindowUtil.openWin("Lua_MultipleServersWindow", WinParam.ACTION_OPEN, {openIdx = 3});
end

function Lua_UpgradeStarWindow:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(140007));
end